#!/usr/bin/perl
#
#Program
#
# 20091010 * updated calculation of def
# 20091010 * updated dimensions order for 3D 
# 20091010 * added 4D
# 20091010 * changed globally sstdc to default to 20 8
# 20091116 * added best and trosy hnco, and added projections
# 20091116 * note that due to bruker processing the direct dimension has a strange phase when bc is performed.
# 20111212 * fixed bruker filter by applying group delay before processing.
# 20120220 * program now takes any pulse sequence, can handle fn mode in the indirect dimensions 5,5 \ 6,5 \ 6,6 hs been tested 
# 20130314 * added 2D trosy support
#
#*************!!!!!!!!!!!!!!!!!!!!    WARNING      !!!!!!!!!!!!!!!!!!***************
#maxmemsize is a system dependent variable and should be set for each system used
# you can check this by typing for linux
#ipcs -ml | grep total | awk '{print $7}'
# for mac
#ipcs -M | grep shmmax | awk '{print $2}'
# the number you get is what you should use as $maxmemsize 
# for more details see the FAQ for rowland nmr toolkit at sbtools.uchc.edu
# SYSTEM DEPENDENT VARIABLES
$maxmemsize=1036870784;
# the above is the maximum size the toolkit currently supports! Do not make this number larger!
$numprocs=8;
#
#*************!!!!!!!!!!!!!!!!!!!!    WARNING      !!!!!!!!!!!!!!!!!!***************

# USAGE genproc.pl -p0 114.2 -p1 123. -r 2 -s 1
#	p0/p1 are phase paramters which can be taken directly from topspin (it is the processing for the direct dimensions)
#	I recommend you do rser 1 and then phase the resulting spectrum using only p0 as there should not be any p1
#	r is to increase the resolution of the output, currently the output resolution is calculated based on the sampling schedule
#	s is to increase the apparent sensitivity of the spectrum, if you have exceptional quality spectra you can use values of 2 or 3 or 4 for this option
#	warning inproper use of -s will lead to peak distortions and nosie gettnig mixed with the signals


use Getopt::Long;
$sens=1;
$inphase0=0.0;
$inphase1=0.0;
$HR=1;
$watersup=0;		

GetOptions('p0=f' => \$inphase0, 
			'p1=f' => \$inphase1,
			's=i' => \$sens,	
			'r=i' => \$HR,	
			'n=i' => \$numprocs,
			'w=i' => \$watersup

			);
			

if ($sens > 4 || $sens < 1)
	{
	print ("***Invalid value for option -s. Default value of 1 will be used.*** \n");	
	$sens=1;

	}
if ($HR > 4 || $HR < 1)
	{
	print ("***Invalid value for option -r. Default value of 1 will be used.*** \n");	
	$HR=1;

	}


$sw_h=0.0;
$sw_2=0.0;
$HN=0;
$file = "extractpars.txt";
open(INFO, $file) || die "Can't open input file";		# Open the file
@input = <INFO>;		# Read it into an array
close(INFO);			# Close the file


$i=0;
#------------ END SET PARAMETERS -------------

foreach $line (@input)
	{
        
		if($line =~ 'SW_hz')
		{
				@fields = split (' ', $line);
				(my $number) = $fields[1] =~ m/\((.*)\)/; # print the number in brackets
				#printf "number = %f \n", $number;
				$sw_h=$number;
				@fields2 = split (',', $line);
				$sw_2=$fields2[1];
				$sw_3=$fields2[2];
				$sw_4=$fields2[3];
				printf "sw = %f %f %f\n", $sw_h, $sw_2, $sw_3, $sw_3;
				
		}
		if($line =~ 'SW_ppm')
		{
				@fields = split (' ', $line);
				(my $number) = $fields[1] =~ m/\((.*)\)/; # print the number in brackets
				#printf "number = %f \n", $number;
				$swp_h=$number;
				@fields2 = split (',', $line);
				$swp_2=$fields2[1];
				$swp_3=$fields2[2];
				$swp_4=$fields2[3];
				printf "sw = %f %f %f\n", $swp_h, $swp_2, $swp_3, $swp_4;
				
		}
		if($line =~ 'O1_ppm')
		{
				@fields = split (' ', $line);
				(my $number) = $fields[1] =~ m/\((.*)\)/; # print the number in brackets
				#printf "number = %f \n", $number;
				$o1_h=$number;
				@fields2 = split (',', $line);
				$o1_2=$fields2[1];
				$o1_3=$fields2[2];
				$o1_4=$fields2[3];

				printf "o1 = %f %f %f\n", $o1_h, $o1_2, $o1_3, $o1_4;
				
		}
		if($line =~ 'SIZE')
		{
				@fields = split (' ', $line);
				(my $number) = $fields[1] =~ m/\((.*)\)/; # print the number in brackets
				#printf "number = %f \n", $number;
				$ni_h=$number;
				@fields2 = split (',', $line);
				$ni_2=$fields2[1];
				$ni_3=$fields2[2];
				$ni_4=$fields2[3];

				printf "NPTS = %f %f %f\n", $ni_h, $ni_2, $ni_3, $ni_4;
				
		}
		if($line =~ 'FnMODE')
		{
				@fields = split (' ', $line);
				(my $number) = $fields[1] =~ m/\((.*)\)/; # print the number in brackets
				#printf "number = %f \n", $number;
				$fn_h=$number;
				@fields2 = split (',', $line);
				$fn_2=$fields2[1];
				$fn_3=$fields2[2];
				$fn_4=$fields2[3];
				printf "quad = %i %i %i %i\n", $fn_h, $fn_2, $fn_3, $fn_4;
		}
		if($line =~ 'PULSEPROGRAM=')
		{
				@fields = split (' ', $line);
				#printf "number = %f \n", $number;
				$pp=$fields[1];

				printf "pp = %s \n", $pp;	
		}				


		if($line =~ 'BYTE')
		{
				@fields = split (' ', $line);
				$byte=$fields[1];
				printf "BYTEORDER = %i \n", $byte;
				
		}
		if($line =~ 'GRPDLY')
		{
				@fields = split (' ', $line);
				(my $number) = $fields[1] =~ m/(.*)\:/; # print the number in brackets
				(my $number2) = $fields[3] =~ m/(.*)\,/; # print the number in brackets
				
				#printf "number = %f \n", $number;
				$grpdly=$number;
				$ph0=$number2;
				$ph1=$fields[5];

				printf "GRPDLY = %f %f %f \n", $grpdly, $ph0, $ph1;
				
		}
				
		
		
	}
close(INFO3);
		$old=0;
	if($byte == 0)
	{
	$bo='Little-endian'
	}
	if($byte == 1)
	{
	$bo='Big-endian'
	}	
# need to add HNCACB, HCCH 3D & 4D	
	if($pp =~ 'nus_cbcaconhgpwg3d'  || $pp =~ 'nus_hncacogpwg3d.t1.be' || $pp =~ 'nus_hncocagpwg3d.n')
	{
		$old=1;
		$HN=1;
		&getsched2d($test, $nlin_2d, $maxvc, $maxvp);
		$flag=0;		
		&printproc1($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR);
	}
#	if($pp =~ 'hbhaconh' )
#	{
#		$old=1;
#		$HN=1;
#		&getsched2d3($test, $nlin_2d, $maxvc, $maxvp);
#		$o1_3=$o1_h-($swp_3)/4;		
#		$flag=0;		
#		&printproc1($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR, $pp);
#	}	
	if($pp =~ 'noesyhsqcetgp3d')
	{
		$old=1;
		$HN=5;
		$flag=1;		
		&printproc_lin($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR, $watersup);
	}

	if($pp =~ 'noesyhsqcfpf3gpsi3d')
	{
		$old=1;
		$HN=1;
		$flag=1;
		$watersup=1;		
		&printproc_lin($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR, $watersup);
	}
	if($pp =~ 'hsqcetfpf3gpsi2'|| $pp =~ 'trosyf3gpphsi19.2' || $pp =~ 'trosyetf3gpsi')
	{
		$old=1;
		$HN=1;
		$flag=1;		
		&printproc_lin2d($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR);
	}
	if($pp =~ 'hbcbcgcchargp_ts21.be')
	{
		$old=1;
		$HN=1;
		$flag=2;		
		&printproc_lin2d($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR);
	}

	
	if($pp =~ 'hsqcetgpsisp2.2')
	{
		$old=1;
		$HN=5;
		$flag=1;		
		&printproc_lin2d($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR);
	}
	if($pp =~ 'sfhmqcf3gpph')
	{
		$old=1;
		$HN=1;
		$flag=0;		
		&printproc_lin2d($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR);
	}
	if($pp =~ 'nus_hncacbgpwg3d.n')
	{
		$old=1;
		$HN=1;

		&getsched2d($test, $nlin_2d, $maxvc, $maxvp);
		$flag=2;		
		&printproc1($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR);
	}

	if($pp =~ 'trhncacbgp3d' || $pp =~ 'cchdigpsi2h3d.t2.be' )
	{
		$old=1;
		$HN=1;
		&getsched2d3($test, $nlin_2d, $maxvc, $maxvp);
		$flag=3;		
		&printproc1($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR);
	}


	if($pp =~ 'nus_hncogp3d.t4.be' || $pp =~ 'nus_hnca.3d' || $pp =~ 'nus_trhncoetgp3d.t1.be' || $pp =~ 'nusb_hncogp3d.t1.be' || $pp =~ 'nus_hncogpwg3d_sct.t1.be')
	{
		$HN=1;
		$old=1;

		&getsched2d($test, $nlin_2d, $maxvc, $maxvp);
		$flag=1;		
		&printproc1($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR);
	}
	if($pp =~ 'nus_hncogpwg3d.t1.be')
	{
		$old=1;
		$HN=1;
		&getsched2d($test, $nlin_2d, $maxvc, $maxvp);
		$flag=0;		
		&printproc1($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR);
		}
	if($pp =~ 'nus_hccconhgpwg3d2.t2.be')
	{
		$old=1;
		$HN=1;

		&getsched2d($test, $nlin_2d, $maxvc, $maxvp);
		$o1_3=$o1_h-($swp_3)/4;
		$flag=0;		
		#printf "%f %f %f\n", $swp_3, $swp_2;
		&printproc1($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR);
	}
	if($pp =~ 'nus_hsqcetfpf3gpsi3d.t1.be')
	{
		$HN=1;
		$old=1;

		&getsched2d($test, $nlin_2d, $maxvc, $maxvp);
		$o1_3=$o1_h+($swp_3)/4;
		$flag=0;		
		#printf "%f %f %f\n", $swp_3, $swp_2;
		&printproc1($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR);
	}	
	
	if($pp =~ 'nus_hccconhgpwg3d3.t2.be' )
	{
		$HN=1;
		$old=1;

		$flag=0;
		&getsched2d($test, $nlin_2d, $maxvc, $maxvp);
		&printproc1($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR);
	}
	if($pp =~ 'hs15n_wtgs_nl.n')
	{
		$HN=1;
		$old=1;
            
		&getsched1d($test, $nlin_1d, $maxvd);
		   &print2d($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_1d, $HN, $maxvd, $sens, $HR);
	}
if($pp =~ 'uqcaiNUSCOSY1.ppg')
{
    $increment=1/$sw_2;
    &getschedcosy($increment,nlin_1d);
    $old=1;
    $HN=5;
    $flag=1;
    $maxvd = 511;
    &print2d($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_1d, $HN, $maxvd, $sens, $HR);
}
	if($pp =~ 'nus_fhsqcf3gpph.t1.be' )
	{
		$HN=1;
		$old=1;

		&getsched1d($test, $nlin_1d, $maxvd);
		   &print2d($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_1d, $HN, $maxvd, $sens, $HR);
	}
	if($pp =~ 'nus_hcchdigp3d.t1.be')
	{
		$HN=5;
		$old=1;
		&getsched2d($test, $nlin_2d, $maxvc, $maxvp);
		$o1_3=$o1_h-($swp_3)/4;
		$flag=0;		
		&printproc1($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR);

	}	
	if($pp =~ 'nus_hcchdigp3d2.t1.be' )
	{
		$old=1;
		$HN=5;
		&getsched2d($test, $nlin_2d, $maxvc, $maxvp);
		$flag=0;		
		&printproc1($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR);

	}
	
	if( $pp =~ 'nus_hsqcetgpsp3d.t1.be')
	{
		$old=1;
		$HN=5;
		&getsched2d($test, $nlin_2d, $maxvc, $maxvp);
		$flag=1;		
		&printproc1($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR);

	}
	if($pp =~ 'nus_hcchdigp4d.t1.be')
	{
		$old=1;
		$HN=5;
		$o1_4=$o1_h-($swp_4)/4;

		$flag=0;
		&getsched3d($test, $nlin_3d, $maxvc, $maxvp, $maxva);
		&printproc2($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $fn_4, $sw_3, $sw_4, $o1_3, $o1_4, $ni_h, $ni_2, $ni_3, $ni_4, $swp_h, $swp_2, $swp_3, $swp_4, $flag, $inphase0, $inphase1, $nlin_3d, $HN, $maxvc, $maxvp, $maxva, $sens, $HR);
	}	
	
	if($pp =~ 'nus_hccconhgpwg4d.t1.be' || $pp =~ 'nus_hccconhgpwgfl4d.t1.be')
	{
		$old=1;
		$HN=1;
		$o1_4=$o1_h-($swp_4)/4;

		$flag=0;
		&getsched3d($test, $nlin_3d, $maxvc, $maxvp, $maxva);
		&printproc2($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $fn_4, $sw_3, $sw_4, $o1_3, $o1_4, $ni_h, $ni_2, $ni_3, $ni_4, $swp_h, $swp_2, $swp_3, $swp_4, $flag, $inphase0, $inphase1, $nlin_3d, $HN, $maxvc, $maxvp, $maxva, $sens, $HR);
	}

	if($old == 0 )
	{
		if($pp =~ 'hn' || $pp =~'nh')
		{
			$HN=1;
		}
		if($pp =~ 'hbha' || $pp =~'hccconh' && $o1_h == $o1_3)
		{
			$o1_3=$o1_3-($swp_3/4.0);
		}
		&getsched2d3($test, $nlin_2d, $maxvc, $maxvp);
		$flag=0;		
		
#		print "doldol $pp, $o1_h, $o1_3, $swp_3\n"   ;

		&printproc1n($ph0, $ph1, $bo, $fn_h, $sw_h, $o1_h, $fn_2, $sw_2, $o1_2, $fn_3, $sw_3, $o1_3, $ni_h, $ni_2, $ni_3, $swp_h, $swp_2, $swp_3, $flag, $inphase0, $inphase1, $nlin_2d, $HN, $maxvc, $maxvp, $sens, $HR, $pp);
		print "This processing script has been generated based on bruker output alone and the results cannot be guaranteed.\n"   ;
	}	


		
#------------------------------------------------------------------------------------------
#ADDED THIS 2012 01 05 FOR A MORE GENERIC GENPROC 
# CURRENTLY ALWAYS ASSUMING DATA IS NUS


sub printproc1n
{
$file2 = "proc_3d_s$sens\_hr$HR.com";
open(INFX, ">$file2") || die "Can't open output file";

print INFX "\#! /bin/sh\n"   ;
print INFX "\n"   ;
#print INFX "echo \"Creating a shared memory section of \$mem_size Mbytes\"\n"   ;
printf INFX "section -c %i %i 2\n", $ni_h*4,  $nlin_2d*4+1  ;
print INFX "\n"   ;
print INFX "echo \'Creating a parameter file for Bruker format and importing data\'\n"   ;
print INFX "if [ -e ser.par ]; then rm ser.par; fi\n"   ;
print INFX "if [ -e ser.dat ]; then mv ser.dat ser.dat.orig; fi\n"   ;
print INFX "if [ -e ser ]; then cp ser ser.dat; else echo \'File ser does not exist! Exiting!\'; exit 1; fi\n"   ;
printf INFX "echo \'Format     %s     int-32\' >> ser.par\n", $bo   ;
print INFX "echo \'DOM     t1     t2     t3\' >> ser.par\n"   ;
printf INFX "echo \"N     %i C    1 C     %i C\" >> ser.par\n", $nlin_2d, $ni_h   ;
printf INFX "echo \'SW    %9.3f %9.3f %9.3f \' >> ser.par\n", $sw_3, $sw_2, $sw_h   ;
printf INFX "echo \'SF     %9.3f %9.3f %9.3f \' >> ser.par\n" , $sw_3/$swp_3, $sw_2/$swp_2, $sw_h/$swp_h    ;
printf INFX "echo \'PPM      %9.3f %9.3f %9.3f \' >> ser.par\n", $o1_3, $o1_2, $o1_h  ;
print INFX "echo \'QUAD     STATES-TPPI     STATES-TPPI     STATES\' >> ser.par\n"   ;
printf INFX "echo \"LAYOUT T1:%i T2:2 T3:%i\" >> ser.par\n", $nlin_2d*2, $ni_h*2   ;
print INFX "rnmrtk LOAD ser.dat\n"   ;
print INFX "rnmrtk SEEPAR\n"   ;
print INFX "rm ser.dat\n"   ;
print INFX "\n"   ;
print INFX "\n"   ;
# $numflag is 1 when ni_h is a fourier number, numflag is 0 when it isn't
$numft=$fnumft=$cnumft=$numflag=$nzftnum=0;
&findftnum($maxvc, $numft, $fnumft, $cnumft, $numflag, $nzftnum);
$maxvc_ft=$nzftnum*2;
$numft=$fnumft=$cnumft=$numflag=$nzftnum=0;
&findftnum($maxvp, $numft, $fnumft, $cnumft, $numflag, $nzftnum);
$maxvp_ft=$nzftnum*2;
$numft=$fnumft=$cnumft=$numflag=$nzftnum=0;

if ($maxvc_ft > 512 && $maxvc < 512)
{
	$maxvc_ft=512
}
if ($maxvp_ft > 512 && $maxvp < 512)
{
	$maxvp_ft=512
}

if ($HR == 2)
{
	$maxvc_ft = $maxvc_ft*2;
	$maxvp_ft = $maxvp_ft*2;		
}
if ($HR == 3)
{
	$maxvc_ft = $maxvc_ft*4;
	$maxvp_ft = $maxvp_ft*4;		
}
if ($HR == 4)
{
	$maxvc_ft = 512;
	$maxvp_ft = 512;		
}
#VC IS CARBON, VP IS NITROGEN
#printf "%i \n", $shnum;
&findftnum($ni_h, $numft, $fnumft, $cnumft, $numflag, $nzftnum);
$shnum=$nzftnum;
if ($HN!=1)
{
$shnum=$nzftnum*2;
}
#printf "%i %i\n", $shnum, $nzftnum;

#	maximum value allowed is 512 512 1024 (technically the value is 2^29-128
if ($maxvc_ft*$maxvp_ft*$shnum > 512*512*2047)	
	{
	printf "The maximum memory size which can be handeled by RNMRTK has been exceeded! \n";
	printf "The resulting script must be modified prior to use, or a smaller data size must be used! \n";
	
#	return;	
	}


print INFX "echo \'Saving time domain data and setting parameters\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "COM \'Taking the complex conjugate of the acquisition dimension to reverse spectra\'\n"   ;
print INFX "DIM t3\n"   ;
print INFX "CONJ\n"   ;
print INFX "COM \'Saving time domain data as time_3d.sec\'\n"   ;
print INFX "SAVE time_3d.sec\n"   ;
print INFX "SEEPAR\n"   ;
print INFX "EOF\n"   ;
print INFX "\n"   ;
print INFX "\n"   ;
print INFX "echo \'Starting t3 fourier transformation of 3D data set for noisecalc\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "DIM t3\n"   ;
print INFX "FFT 1.0\n"   ;
printf INFX "PHASE %9.3f %9.3f\n", $ph0, $ph1   ;
printf INFX "PHASE %9.3f %9.3f\n", $inphase0, $inphase1 ;
print INFX "IFFT 1.0\n"   ;
if ($fn_2 == 6 ) {
print INFX "SEFIX1 t2 \n";
}
if ($fn_3 == 6 ) {
print INFX "SEFIX1 t1 \n";
}
if ($HN==1) 
{
print INFX "SSTDC 8 20 0.00\n"   ;
}
print INFX "BC 12.5\n"   ;
print INFX "GM 20.00 20.00\n"   ;
printf INFX "ZEROFILL \n"; # zerofill gets done regardles of shnum, so when shrinking later the data is shrunk to half it's size

if ($numflag==3)
	{
printf INFX "ZEROFILL \n";		# zerofill twice if the number points is not a fourier number and is near the next fourier number
	}

print INFX "FFT 1.0\n";
print INFX "COM \'Saving f3 processed data as noisecalc.sec\'\n"   ;
print INFX "SAVE noisecalc.sec\n"   ;
print INFX "SEEPAR\n"   ;
print INFX "EOF\n"   ;
print INFX "if [ -e noisecalc1.txt ]; then rm noisecalc1.txt; fi\n"   ;
print INFX "if [ -e noisecalc2.txt ]; then rm noisecalc2.txt; fi\n"   ;
print INFX "echo \'Determining Def and Aim based on noise in last FID or separate noise spectrum (noisecalc1.txt) and\'\n"   ;
print INFX "echo \'Finding the 10 largest signals outside the central region (noisecalc2.txt)\'\n"   ;
print INFX "if [ -e load_noisecalc.sh ]; then rm load_noisecalc.sh; fi\n"   ;
print INFX "echo \'i=\$1\' >> load_noisecalc.sh\n"   ;
print INFX "echo \'rnmrtk << EOF\' >> load_noisecalc.sh\n"   ;
print INFX "echo \'LOAD noisecalc.sec\' >> load_noisecalc.sh\n"   ;
print INFX "echo \'DIM t2\' >> load_noisecalc.sh\n"   ;
print INFX "echo \'SHRINK 1 \${i}\' >> load_noisecalc.sh\n"   ;
print INFX "echo \'SETPAR DOM F1\' >> load_noisecalc.sh\n"   ;
print INFX "echo \'EOF\' >> load_noisecalc.sh\n"   ;
#print INFX "sleep 1\n"   ;
printf INFX "sh ./load_noisecalc.sh %i \n", $nlin_2d   ;
#noisecalc noise percent, nih, ni collected in dim2, ni collected in dim3-if nus then this is often 1, npts after zf in dim2, dim3, dimension number where directect dimension lies for 1d this is simply 1 
if ($sens == 1)
{
					printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 noisecalc1.txt\n", $ni_h, $nlin_2d, $maxvc_ft*$maxvp_ft, 1 ;
}elsif ($sens==2){	printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 noisecalc1.txt\n", $ni_h, $nlin_2d, $maxvc_ft*10*$maxvp_ft, 1 ;
}elsif ($sens==3){	printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 noisecalc1.txt\n", $ni_h, $nlin_2d, $maxvc_ft*100*$maxvp_ft, 1 ;
}elsif ($sens==4){	printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 noisecalc1.txt\n", $ni_h, $nlin_2d, $maxvc_ft*1000*$maxvp_ft, 1 ;

}
	if($pp =~ 'hncacb')
	{
	printf INFX "rnmrtk load noisecalc.sec \n";
	printf INFX "rnmrtk dim 3 ifft\n";
	printf INFX "rnmrtk dim 3 xsect 1 \n";
	printf INFX "rnmrtk setpar dom f1 \n";
	printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 amp.txt\n  \n", $ni_h, $nlin_2d, $maxvc_ft*$maxvp_ft, 1 ;
	print INFX "MAXAMP=`grep Highest amp.txt | awk \'{print \$8}\'`\n"   ;
	print INFX "if [ \$MAXAMP = \"0.00\" ]; then echo \'Highest amplitude along indirect dimension not defined. Aborting!\'; exit 1; fi\n"   ;
	print INFX "sh ./load_noisecalc.sh \$MAXAMP \n"   ;	# defaults to first fid but could be changed for HNCACB and COSY type sp	

	}else{
	print INFX "sh ./load_noisecalc.sh 1 \n"   ;	# defaults to first fid but could be changed for HNCACB and COSY type spectra.
	}
if ($sens == 1)
{
					printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 noisecalc2.txt\n", $ni_h, $nlin_2d, $maxvc_ft*$maxvp_ft, 1 ;
}elsif ($sens==2){	printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 noisecalc2.txt\n", $ni_h, $nlin_2d, $maxvc_ft*10*$maxvp_ft, 1 ;
}elsif ($sens==3){	printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 noisecalc2.txt\n", $ni_h, $nlin_2d, $maxvc_ft*100*$maxvp_ft, 1 ;
}elsif ($sens==4){	printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 noisecalc2.txt\n", $ni_h, $nlin_2d, $maxvc_ft*1000*$maxvp_ft, 1 ;

}
print INFX "\n"   ;
print INFX "echo \'Starting t3 fourier transformation of 3D data set\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "LOAD time_3d.sec\n"   ;
print INFX "DIM t3\n";
print INFX "FFT 1.0\n"   ;
printf INFX "PHASE %9.3f %9.3f\n", $ph0, $ph1   ;
printf INFX "PHASE %9.3f %9.3f\n", $inphase0, $inphase1 ;
print INFX "IFFT 1.0\n"   ;
if ($fn_2 == 6 ) {
print INFX "SEFIX1 t2 \n";
}
if ($fn_3 == 6 ) {
print INFX "SEFIX1 t1 \n";
}

#if ($flag == 3) 
#{
#print INFX "DIM T2 \n";
#print INFX "CONJ \n";
#print INFX "DIM T3 \n";
#print INFX "SEFIX1 T2 \n";
#}


if ($HN==1) 
{
print INFX "SSTDC 8 20 0.00\n"   ;
}
print INFX "BC 12.5\n"   ;
print INFX "GM 20.00 20.00\n"   ;
printf INFX "ZEROFILL \n";

if ($numflag==3)
	{
printf INFX "ZEROFILL \n";		# zerofill twice if the number points is not a fourier number and is near the next fourier number
	};
print INFX "FFT 1.0\n"   ;
print INFX "COM \'Shrinking of data will occur after Lambda is determined\'\n"   ;
print INFX "REALPART\n"   ;
print INFX "COM \'Saving f3 processed data as f3_proc.sec\'\n"   ;
print INFX "SAVE f3_proc.sec\n"   ;
print INFX "SEEPAR\n"   ;
print INFX "EOF\n"   ;
print INFX "\n"   ;
printf INFX "export MP_SET_NUMTHREADS=%i\n", $numprocs   ;
print INFX "echo \'Determining DEF and AIM values based on noise in last FID\'\n"   ;
print INFX "if [ -e msa2d_test.txt ]; then rm msa2d_test.txt; fi\n"   ;
print INFX "if [ -e msa2d.txt ]; then rm msa2d.txt; fi\n"   ;
print INFX "AIM_LAST_FID=`grep \'AIM for first indirect dimension\' noisecalc1.txt | awk \' {aim = \$7}; END {printf \"\%.2f\", aim} \'`\n"   ;
print INFX "DEF_LAST_FID=`grep \'DEF for first indirect dimension\' noisecalc1.txt | awk \' {def = \$7}; END {printf \"\%.2f\", def} \'`\n"   ;
print INFX "echo \"AIM_LAST_FID = \$AIM_LAST_FID\"\n"   ;
print INFX "echo \"DEF_LAST_FID = \$DEF_LAST_FID\"\n"   ;
print INFX "if [ \$AIM_LAST_FID = \"0.00\" ]; then echo \'AIM_LAST_FID not defined. Aborting!\'; exit 1; fi\n"   ;
print INFX "if [ \$DEF_LAST_FID = \"0.00\" ]; then echo \'DEF_LAST_FID not defined. Aborting!\'; exit 1; fi\n"   ;
print INFX "\n"   ;
print INFX "echo \'Creating a test MSA2D parameter file to determine LAMBDA\'\n"   ;
print INFX "if [ -e msa2d_test_param ]; then rm msa2d_test_param; fi\n"   ;
print INFX "if [ -e msa2d_param ]; then rm msa2d_param; fi\n"   ;
print INFX "touch msa2d_test_param msa2d_param\n"   ;
print INFX "echo \'DEBUG 2\' >> msa2d_test_param\n"   ;
print INFX "echo \'NLOOPS 1400\' >> msa2d_test_param\n"   ;
print INFX "echo \"DEF \$DEF_LAST_FID\" >> msa2d_test_param\n"   ;
print INFX "echo \"AIM \$AIM_LAST_FID\" >> msa2d_test_param\n"   ;
print INFX "echo \'SCALEFIRST 0.5\' >> msa2d_test_param\n"   ;
print INFX "echo \'SCHED ./tlkt.scd\' >> msa2d_test_param\n"   ;	# tlkt.scd is arranged to have vp, vc
printf INFX "echo \'NOUT %i %i\' >> msa2d_test_param\n" , $maxvp_ft, $maxvc_ft; # vp is first indirect dimension and vc is second (t2/f2 in this case)
print INFX "echo \'PHASE 0.0 0.0 0.0 0.0\' >> msa2d_test_param\n"   ;
print INFX "echo \'LW 0.0 0.0\' >> msa2d_test_param\n"   ;
print INFX "echo \'JVALUE 0.0 0.0\' >> msa2d_test_param\n"   ;
print INFX "sleep 1\n"   ;
print INFX "\n"   ;
print INFX "echo \'Running MSA2D calculation for 10 planes with highest intensity to determine LAMBDA\'\n"   ;
print INFX "echo \'Capturing the result as msa2d_test.txt. Please be patient!\'\n"   ;
print INFX "i=0\n"   ;
print INFX "j=0\n"   ;
print INFX "while [ \${i} -lt 10 ]\n"   ;
print INFX "do\n"   ;
print INFX "  j=\$((\${i}+8))\n"   ;
print INFX "  i=\$((\${i}+1))\n"   ;
print INFX "  PLANE=`grep \'Highest peak amplitued points outside central region\' noisecalc2.txt | awk -v col=\"\$j\" \' {column = \$col}; END {printf \"\%.0f\", column} \'`\n"   ;
print INFX "  echo \"Loading plane \$i of 10, Plane number \$PLANE\"\n"   ;
print INFX "  rnmrtk LOAD f3_proc.sec dim f3 t1 t2 num 1 start \$PLANE\n"   ;
print INFX "  msa2d t2 t1 ./msa2d_test_param >> msa2d_test.txt\n"   ;	# so since tlkt.scd is t2 t1 then msa must be t2 t1
print INFX "done\n"   ;
print INFX "LAMBDA=`grep \'Lambda =\' msa2d_test.txt | sed \"s/=/= /g\" | awk \' /Lambda = / { ++num }; {total += \$6}; {ave = total/num}; END {printf \"\%.2f\", ave}\'`\n"   ;
print INFX "echo \"Lambda determined to be \$LAMBDA\"\n"   ;
print INFX "if [ \$LAMBDA = \"0.00\" ]; then echo \'LAMBDA not defined. Aborting!\'; exit 1; fi\n"   ;
print INFX "LOOPS=`grep \'Loop\' msa2d_test.txt | awk \' \$2 > max {max=\$2}; END {print max}\'`\n"   ;
print INFX "if [ \"\$LOOPS\" = \"1400\" ]\n"   ;
print INFX "then\n"   ;
print INFX "  echo \'MSA2D did not converge in the correct number of loops. Aborting!\'\n"   ;
print INFX "  exit 1\n"   ;
print INFX "fi\n"   ;
print INFX "\n"   ;
print INFX "echo \'Cutting direct dimension in half prior to MSA calculation\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "LOAD f3_proc.sec\n"   ;
print INFX "DIM F3\n"   ;
	if ($HN == 1)
	{	
printf INFX "SHRINK %i 1\n", $shnum   ;
	}
print INFX "SAVE f3_proc.sec\n"   ;
print INFX "EOF\n"   ;
print INFX "\n"   ;
print INFX "section -d\n"   ;
printf INFX "section -c %i %i %i\n", $maxvp_ft*2, $maxvc_ft*2,  $numprocs*2  ;
print INFX "\n"   ;
print INFX "echo \'Creating MSA2D parameter file with constant Lambda for final MSA2D calculation\'\n"   ;
print INFX "echo \'DEBUG 2\' >> msa2d_param\n"   ;
print INFX "echo \'NLOOPS 1400\' >> msa2d_param\n"   ;
print INFX "echo \"DEF \$DEF_LAST_FID\" >> msa2d_param\n"   ;
print INFX "echo \"LAMBDA \$LAMBDA\" >> msa2d_param\n"   ;
print INFX "echo \'SCALEFIRST 0.5\' >> msa2d_param\n"   ;
print INFX "echo \'SCHED ./tlkt.scd\' >> msa2d_param\n"   ;
printf INFX "echo \'NOUT %i %i\' >> msa2d_param\n" , $maxvp_ft, $maxvc_ft;	# see above for dimensions order (first iteration)
print INFX "echo \'PHASE 0.0 0.0 0.0 0.0\' >> msa2d_param\n"   ;
print INFX "echo \'LW 0.0 0.0\' >> msa2d_param\n"   ;
print INFX "echo \'JVALUE 0.0 0.0\' >> msa2d_param\n"   ;
print INFX "sleep 1\n"   ;
print INFX "\n"   ;
print INFX "echo \'Data will be processed as 2D chunks to reduce memory requirements\'\n"   ;
print INFX "if [ -d tmp_chunks ]; then rm -r tmp_chunks; fi\n"   ;
print INFX "mkdir tmp_chunks\n"   ;
print INFX "i=1\n"   ;
print INFX "j=1\n"   ;
printf INFX "while [ \${j} -lt %i ]\n", ($shnum/$numprocs)+1   ;
print INFX "do\n"   ;
print INFX "  echo \'\'\n"   ;
printf INFX "  echo \"Chunk: \${j} of %i \"\n", ($shnum/$numprocs)  ;
print INFX "  echo \"MSA2D calculation running with DEF = \$DEF_LAST_FID, LAMBDA = \$LAMBDA\"\n"   ;
printf INFX "  rnmrtk LOAD f3_proc.sec dim f3 t1 t2 num %i start \${i}\n", $numprocs   ;
print INFX "  msa2d t2 t1 ./msa2d_param >> msa2d.txt\n"   ;
print INFX "  rnmrtk dim 1 realpart \n"   ;
print INFX "  rnmrtk dim 2 realpart \n"   ;
print INFX "  rnmrtk dim 3 realpart \n"   ;
print INFX "  rnmrtk SAVE tmp_chunks/chunk\${j}.sec\n"   ;
printf INFX "  i=\$((\${i}+%i))\n",$numprocs   ;
print INFX "  j=\$((\${j}+1))\n"   ;
print INFX "done\n"   ;
print INFX "\n"   ;
print INFX "\n"   ;
print INFX "section -d\n"   ;
if ($maxvp_ft*$maxvc_ft*$shnum > $maxmemsize )
{
print "WARNING THE PROCESSING SCRIPT PRODUCED WILL NOT HAVE ENOUGH MEMORY AVAILABEL FOR AUTOMATIC PROCESSING OF THIS DATA, TRY ONE OF THE FOLLOWING!"	;
print "1.MAKE SURE THE SYSTEM SETTINGS AT THE TOP OF GENPROC.PRL ARE SET APPROPRIATELY."	;
print "2.USE A COMPUTER WITH MORE AVAILABLE DATA FOR SHARED MEMORY SECTION."	;
print "3.MODIFY THE OUTPUT TO CREATE A SMALLER DATASIZE (I.E. BY CHANGING NPTS IN ONE OF THE DIMENSIONS)."	;
}
printf INFX "section -c %i %i %i\n", $maxvp_ft, $maxvc_ft, $shnum;
print INFX "\n"   ;
print INFX "echo \'Saving MSA2D data from individual planes into single Rowland NMRToolkit file\'\n"   ;
print INFX "if [ -e temp.sec ]; then rm temp.sec; fi\n"   ;
print INFX "if [ -e combine.sh ]; then rm combine.sh; fi\n"   ;
print INFX "if [ -e combine.log ]; then rm combine.log; fi\n"   ;
print INFX "touch temp.sec combine.sh\n"   ;
print INFX "echo \'i=\$1\' >> combine.sh\n"   ;
print INFX "echo \'rnmrtk << EOF\' >> combine.sh\n"   ;
print INFX "echo \'LOAD tmp_chunks/chunk\${i}.sec\' >> combine.sh \n"   ;
#	if($pp == 5 )
#	{
#if ($flag == 0 || $flag == 2) {
#print INFX "echo \'DIM f2\' >> combine.sh\n"   ;
#print INFX "echo \'REVERSE\' >> combine.sh\n"   ;
	if($fn_2 == 5 )
	{
	print INFX "echo \'DIM f2\' >> combine.sh\n"   ;
	printf INFX "echo \'ROTATE %i\' >> combine.sh\n", $maxvp_ft/2.0; # vp is first indirect dimension and vc is second (t2 t1 in this case) 
	$o1_2=$o1_2-($swp_2/2.0);
	printf INFX "echo \'SETPAR PPM2 %9.3f\' >> combine.sh\n", $o1_2 ;
		if($fn_3 != 5)
		{
			print INFX "echo \'REVERSE\' >> combine.sh\n"   ;
		}
	}
#}
#if ($flag == 0 || $flag == 1) {
#print INFX "echo \'DIM f1\' >> combine.sh\n"   ;
#print INFX "echo \'REVERSE\' >> combine.sh\n"   ;
	if($fn_3 == 5 )
	{
	print INFX "echo \'DIM f1\' >> combine.sh\n"   ;
	printf INFX "echo \'ROTATE %i\' >> combine.sh\n", $maxvc_ft/2.0; # vp is first indirect dimension and vc is second (t2 t1 in this case) 
	$o1_3=$o1_3-($swp_3/2.0);
	printf INFX "echo \'SETPAR PPM1 %9.3f\' >> combine.sh\n", $o1_3 ;
	print INFX "echo \'REVERSE\' >> combine.sh\n"   ;	
	}
#}

print INFX "echo \'APPEND temp.sec\' >> combine.sh\n"   ;
print INFX "echo \'EOF\' >> combine.sh\n"   ;
print INFX "sleep 1\n"   ;
print INFX "j=1\n"   ;
printf INFX "while [ \${j} -lt %i ]\n", ($shnum/$numprocs)+1   ;
print INFX "do\n"   ;
print INFX "  sh ./combine.sh \${j} >> combine.log\n"   ;
print INFX "  j=\$((\${j}+1))\n"   ;
print INFX "done\n"   ;
print INFX "rm -r tmp_chunks\n"   ;
print INFX "rnmrtk LOAD temp.sec f1 f2 f3\n"   ;
print INFX "\n"   ;
printf INFX "echo \'Saving final data in NMRPipe format as %s.ft3\'\n", $pp   ;
print INFX "echo \'If the file exists it will be overwritten!\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
printf INFX "PUTNMRPIPE %s_f3f2.ft3 f3 f1\n", $pp   ;
printf INFX "PUTXEASY %s. other\n", $pp   ;
printf INFX "load temp.sec\n"   ;
printf INFX "dim 2 xsect sum\n"   ;
printf INFX "putnmrpipe f2_proj.ft2\n"   ;
printf INFX "load temp.sec\n"   ;
printf INFX "dim 1 xsect sum\n"   ;
printf INFX "putnmrpipe f1_proj.ft2\n"   ;
print INFX "EOF\n"   ;
print INFX "\n"   ;
print INFX "echo \'Removing shared memory section\'\n"   ;
print INFX "section -d\n"   ;
print INFX "\n"   ;
print INFX "echo \'Examining output from MSA2D calculation for convergence. Please be patient!\'\n"   ;
print INFX "LOOPS=`grep \'Loop\' msa2d.txt | sort -n -k 2 | awk \' {loops = \$2}; END {print loops}\'`\n"   ;
print INFX "echo \"The largest number of loops to achieve convergence in msa2d.txt is \$LOOPS\"\n"   ;
print INFX "if [ \"\$LOOPS\" = \"1400\" ]\n"   ;
print INFX "then\n"   ;
print INFX "  echo \'MSA2D did not converge in the correct number of loops\'\n"   ;
print INFX "fi\n"   ;
print INFX "\n"   ;
print INFX "echo \"Initial MSA2D calculation was performed with DEF = \$DEF_LAST_FID and AIM = \$AIM_LAST_FID with constant AIM\"\n"   ;
print INFX "echo \"to determine LAMBDA. Final MSA2D calculation performed with DEF = \$DEF_LAST_FID and LAMBDA = \$LAMBDA\"\n"   ;
print INFX "\n"   ;
print INFX "echo \'Remove comments to clean up intermediate files.\'\n"   ;
print INFX "rm time_3d.sec time_3d.par f3_proc.sec f3_proc.par\n"   ;
print INFX "rm msa2d_test.txt msa2d_test_param noisecalc1.txt noisecalc2.txt load_noisecalc.sh combine.sh combine.log\n"   ;
print INFX "\n"   ;
}



#*************************** CREATE PROCESSING SCRIPT FOR 3D ******************************
sub printproc1
{
$file2 = "proc_3d_s$sens\_hr$HR.com";
open(INFX, ">$file2") || die "Can't open output file";

print INFX "\#! /bin/sh\n"   ;
print INFX "\n"   ;
#print INFX "echo \"Creating a shared memory section of \$mem_size Mbytes\"\n"   ;
printf INFX "section -c %i %i 2\n", $ni_h*4,  $nlin_2d*4+1  ;
print INFX "\n"   ;
print INFX "echo \'Creating a parameter file for Bruker format and importing data\'\n"   ;
print INFX "if [ -e ser.par ]; then rm ser.par; fi\n"   ;
print INFX "if [ -e ser.dat ]; then mv ser.dat ser.dat.orig; fi\n"   ;
print INFX "if [ -e ser ]; then cp ser ser.dat; else echo \'File ser does not exist! Exiting!\'; exit 1; fi\n"   ;
printf INFX "echo \'Format     %s     int-32\' >> ser.par\n", $bo   ;
print INFX "echo \'DOM     t1     t2     t3\' >> ser.par\n"   ;
printf INFX "echo \"N     %i C    1 C     %i C\" >> ser.par\n", $nlin_2d, $ni_h   ;
printf INFX "echo \'SW    %9.3f %9.3f %9.3f \' >> ser.par\n", $sw_3, $sw_2, $sw_h   ;
printf INFX "echo \'SF     %9.3f %9.3f %9.3f \' >> ser.par\n" , $sw_3/$swp_3, $sw_2/$swp_2, $sw_h/$swp_h    ;
printf INFX "echo \'PPM      %9.3f %9.3f %9.3f \' >> ser.par\n", $o1_3, $o1_2, $o1_h  ;
print INFX "echo \'QUAD     STATES-TPPI     STATES-TPPI     STATES\' >> ser.par\n"   ;
printf INFX "echo \"LAYOUT T1:%i T2:2 T3:%i\" >> ser.par\n", $nlin_2d*2, $ni_h*2   ;
print INFX "rnmrtk LOAD ser.dat\n"   ;
print INFX "rnmrtk SEEPAR\n"   ;
print INFX "rm ser.dat\n"   ;
print INFX "\n"   ;
print INFX "\n"   ;
# $numflag is 1 when ni_h is a fourier number, numflag is 0 when it isn't
$numft=$fnumft=$cnumft=$numflag=$nzftnum=0;
&findftnum($maxvc, $numft, $fnumft, $cnumft, $numflag, $nzftnum);
$maxvc_ft=$nzftnum*2;
$numft=$fnumft=$cnumft=$numflag=$nzftnum=0;
&findftnum($maxvp, $numft, $fnumft, $cnumft, $numflag, $nzftnum);
$maxvp_ft=$nzftnum*2;
$numft=$fnumft=$cnumft=$numflag=$nzftnum=0;

if ($maxvc_ft > 512 && $maxvc < 512)
{
	$maxvc_ft=512
}
if ($maxvp_ft > 512 && $maxvp < 512)
{
	$maxvp_ft=512
}

if ($HR == 2)
{
	$maxvc_ft = $maxvc_ft*2;
	$maxvp_ft = $maxvp_ft*2;		
}
if ($HR == 3)
{
	$maxvc_ft = $maxvc_ft*4;
	$maxvp_ft = $maxvp_ft*4;		
}
if ($HR == 4)
{
	$maxvc_ft = 512;
	$maxvp_ft = 512;		
}
#VC IS CARBON, VP IS NITROGEN
#printf "%i \n", $shnum;
&findftnum($ni_h, $numft, $fnumft, $cnumft, $numflag, $nzftnum);
$shnum=$nzftnum;
if ($HN!=1)
{
$shnum=$nzftnum*2;
}
#printf "%i %i\n", $shnum, $nzftnum;

#	maximum value allowed is 512 512 1024 (technically the value is 2^29-128
if ($maxvc_ft*$maxvp_ft*$shnum > 512*512*2047)	
	{
	printf "The maximum memory size which can be handeled by RNMRTK has been exceeded! \n";
	printf "The resulting script must be modified prior to use, or a smaller data size must be used! \n";
	
#	return;	
	}


print INFX "echo \'Saving time domain data and setting parameters\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "COM \'Taking the complex conjugate of the acquisition dimension to reverse spectra\'\n"   ;
print INFX "DIM t3\n"   ;
print INFX "CONJ\n"   ;
print INFX "COM \'Saving time domain data as time_3d.sec\'\n"   ;
print INFX "SAVE time_3d.sec\n"   ;
print INFX "SEEPAR\n"   ;
print INFX "EOF\n"   ;
print INFX "\n"   ;
print INFX "\n"   ;
print INFX "echo \'Starting t3 fourier transformation of 3D data set for noisecalc\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "DIM t3\n"   ;
print INFX "FFT 1.0\n"   ;
printf INFX "PHASE %9.3f %9.3f\n", $ph0, $ph1   ;
printf INFX "PHASE %9.3f %9.3f\n", $inphase0, $inphase1 ;
print INFX "IFFT 1.0\n"   ;

if ($HN!=5) 
{
print INFX "SSTDC 8 20 0.00\n"   ;
}
print INFX "BC 12.5\n"   ;
print INFX "GM 20.00 20.00\n"   ;
printf INFX "ZEROFILL \n"; # zerofill gets done regardles of shnum, so when shrinking later the data is shrunk to half it's size

if ($numflag==3)
	{
printf INFX "ZEROFILL \n";		# zerofill twice if the number points is not a fourier number and is near the next fourier number
	}

print INFX "FFT 1.0\n";
print INFX "COM \'Saving f3 processed data as noisecalc.sec\'\n"   ;
print INFX "SAVE noisecalc.sec\n"   ;
print INFX "SEEPAR\n"   ;
print INFX "EOF\n"   ;
print INFX "if [ -e noisecalc1.txt ]; then rm noisecalc1.txt; fi\n"   ;
print INFX "if [ -e noisecalc2.txt ]; then rm noisecalc2.txt; fi\n"   ;
print INFX "echo \'Determining Def and Aim based on noise in last FID or separate noise spectrum (noisecalc1.txt) and\'\n"   ;
print INFX "echo \'Finding the 10 largest signals outside the central region (noisecalc2.txt)\'\n"   ;
print INFX "if [ -e load_noisecalc.sh ]; then rm load_noisecalc.sh; fi\n"   ;
print INFX "echo \'i=\$1\' >> load_noisecalc.sh\n"   ;
print INFX "echo \'rnmrtk << EOF\' >> load_noisecalc.sh\n"   ;
print INFX "echo \'LOAD noisecalc.sec\' >> load_noisecalc.sh\n"   ;
print INFX "echo \'DIM t2\' >> load_noisecalc.sh\n"   ;
print INFX "echo \'SHRINK 1 \${i}\' >> load_noisecalc.sh\n"   ;
print INFX "echo \'SETPAR DOM F1\' >> load_noisecalc.sh\n"   ;
print INFX "echo \'EOF\' >> load_noisecalc.sh\n"   ;
#print INFX "sleep 1\n"   ;
printf INFX "sh ./load_noisecalc.sh %i \n", $nlin_2d   ;
#noisecalc noise percent, nih, ni collected in dim2, ni collected in dim3-if nus then this is often 1, npts after zf in dim2, dim3, dimension number where directect dimension lies for 1d this is simply 1 
if ($sens == 1)
{
					printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 noisecalc1.txt\n", $ni_h, $nlin_2d, $maxvc_ft*$maxvp_ft, 1 ;
}elsif ($sens==2){	printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 noisecalc1.txt\n", $ni_h, $nlin_2d, $maxvc_ft*10*$maxvp_ft, 1 ;
}elsif ($sens==3){	printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 noisecalc1.txt\n", $ni_h, $nlin_2d, $maxvc_ft*100*$maxvp_ft, 1 ;
}elsif ($sens==4){	printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 noisecalc1.txt\n", $ni_h, $nlin_2d, $maxvc_ft*1000*$maxvp_ft, 1 ;

}
	if($pp =~ 'nus_hncacbgpwg3d.n')
	{
	printf INFX "rnmrtk load noisecalc.sec \n";
	printf INFX "rnmrtk dim 3 ifft\n";
	printf INFX "rnmrtk dim 3 xsect 1 \n";
	printf INFX "rnmrtk setpar dom f1 \n";
	printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 amp.txt\n  \n", $ni_h, $nlin_2d, $maxvc_ft*$maxvp_ft, 1 ;
	print INFX "MAXAMP=`grep Highest amp.txt | awk \'{print \$8}\'`\n"   ;
	print INFX "if [ \$MAXAMP = \"0.00\" ]; then echo \'Highest amplitude along indirect dimension not defined. Aborting!\'; exit 1; fi\n"   ;
	print INFX "sh ./load_noisecalc.sh \$MAXAMP \n"   ;	# defaults to first fid but could be changed for HNCACB and COSY type sp	

	}
	else
	{
	print INFX "sh ./load_noisecalc.sh 1 \n"   ;	# defaults to first fid but could be changed for HNCACB and COSY type spectra.
	}
if ($sens == 1)
{
					printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 noisecalc2.txt\n", $ni_h, $nlin_2d, $maxvc_ft*$maxvp_ft, 1 ;
}elsif ($sens==2){	printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 noisecalc2.txt\n", $ni_h, $nlin_2d, $maxvc_ft*10*$maxvp_ft, 1 ;
}elsif ($sens==3){	printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 noisecalc2.txt\n", $ni_h, $nlin_2d, $maxvc_ft*100*$maxvp_ft, 1 ;
}elsif ($sens==4){	printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 noisecalc2.txt\n", $ni_h, $nlin_2d, $maxvc_ft*1000*$maxvp_ft, 1 ;

}
print INFX "\n"   ;
print INFX "echo \'Starting t3 fourier transformation of 3D data set\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "LOAD time_3d.sec\n"   ;
print INFX "DIM t3\n";
print INFX "FFT 1.0\n"   ;
printf INFX "PHASE %9.3f %9.3f\n", $ph0, $ph1   ;
printf INFX "PHASE %9.3f %9.3f\n", $inphase0, $inphase1 ;
print INFX "IFFT 1.0\n"   ;

if ($flag == 1 ) {
print INFX "SEFIX1 t2 \n";
}
if ($flag == 3) 
{
print INFX "DIM T2 \n";
print INFX "CONJ \n";
print INFX "DIM T3 \n";
print INFX "SEFIX1 T2 \n";
}


if ($HN!=5) 
{
print INFX "SSTDC 8 20 0.00\n"   ;
}
print INFX "BC 12.5\n"   ;
print INFX "GM 20.00 20.00\n"   ;
printf INFX "ZEROFILL \n";

if ($numflag==3)
	{
printf INFX "ZEROFILL \n";		# zerofill twice if the number points is not a fourier number and is near the next fourier number
	};
print INFX "FFT 1.0\n"   ;
print INFX "COM \'Shrinking of data will occur after Lambda is determined\'\n"   ;
print INFX "REALPART\n"   ;
print INFX "COM \'Saving f3 processed data as f3_proc.sec\'\n"   ;
print INFX "SAVE f3_proc.sec\n"   ;
print INFX "SEEPAR\n"   ;
print INFX "EOF\n"   ;
print INFX "\n"   ;
printf INFX "export MP_SET_NUMTHREADS=%i\n", $numprocs   ;
print INFX "echo \'Determining DEF and AIM values based on noise in last FID\'\n"   ;
print INFX "if [ -e msa2d_test.txt ]; then rm msa2d_test.txt; fi\n"   ;
print INFX "if [ -e msa2d.txt ]; then rm msa2d.txt; fi\n"   ;
print INFX "AIM_LAST_FID=`grep \'AIM for first indirect dimension\' noisecalc1.txt | awk \' {aim = \$7}; END {printf \"\%.2f\", aim} \'`\n"   ;
print INFX "DEF_LAST_FID=`grep \'DEF for first indirect dimension\' noisecalc1.txt | awk \' {def = \$7}; END {printf \"\%.2f\", def} \'`\n"   ;
print INFX "echo \"AIM_LAST_FID = \$AIM_LAST_FID\"\n"   ;
print INFX "echo \"DEF_LAST_FID = \$DEF_LAST_FID\"\n"   ;
print INFX "if [ \$AIM_LAST_FID = \"0.00\" ]; then echo \'AIM_LAST_FID not defined. Aborting!\'; exit 1; fi\n"   ;
print INFX "if [ \$DEF_LAST_FID = \"0.00\" ]; then echo \'DEF_LAST_FID not defined. Aborting!\'; exit 1; fi\n"   ;
print INFX "\n"   ;
print INFX "echo \'Creating a test MSA2D parameter file to determine LAMBDA\'\n"   ;
print INFX "if [ -e msa2d_test_param ]; then rm msa2d_test_param; fi\n"   ;
print INFX "if [ -e msa2d_param ]; then rm msa2d_param; fi\n"   ;
print INFX "touch msa2d_test_param msa2d_param\n"   ;
print INFX "echo \'DEBUG 2\' >> msa2d_test_param\n"   ;
print INFX "echo \'NLOOPS 1400\' >> msa2d_test_param\n"   ;
print INFX "echo \"DEF \$DEF_LAST_FID\" >> msa2d_test_param\n"   ;
print INFX "echo \"AIM \$AIM_LAST_FID\" >> msa2d_test_param\n"   ;
print INFX "echo \'SCALEFIRST 0.5\' >> msa2d_test_param\n"   ;
print INFX "echo \'SCHED ./tlkt.scd\' >> msa2d_test_param\n"   ;	# tlkt.scd is arranged to have vp, vc
printf INFX "echo \'NOUT %i %i\' >> msa2d_test_param\n" , $maxvp_ft, $maxvc_ft; # vp is first indirect dimension and vc is second (t2/f2 in this case)
print INFX "echo \'PHASE 0.0 0.0 0.0 0.0\' >> msa2d_test_param\n"   ;
print INFX "echo \'LW 0.0 0.0\' >> msa2d_test_param\n"   ;
print INFX "echo \'JVALUE 0.0 0.0\' >> msa2d_test_param\n"   ;
print INFX "sleep 1\n"   ;
print INFX "\n"   ;
print INFX "echo \'Running MSA2D calculation for 10 planes with highest intensity to determine LAMBDA\'\n"   ;
print INFX "echo \'Capturing the result as msa2d_test.txt. Please be patient!\'\n"   ;
print INFX "i=0\n"   ;
print INFX "j=0\n"   ;
print INFX "while [ \${i} -lt 10 ]\n"   ;
print INFX "do\n"   ;
print INFX "  j=\$((\${i}+8))\n"   ;
print INFX "  i=\$((\${i}+1))\n"   ;
print INFX "  PLANE=`grep \'Highest peak amplitued points outside central region\' noisecalc2.txt | awk -v col=\"\$j\" \' {column = \$col}; END {printf \"\%.0f\", column} \'`\n"   ;
print INFX "  echo \"Loading plane \$i of 10, Plane number \$PLANE\"\n"   ;
print INFX "  rnmrtk LOAD f3_proc.sec dim f3 t1 t2 num 1 start \$PLANE\n"   ;
print INFX "  msa2d t2 t1 ./msa2d_test_param >> msa2d_test.txt\n"   ;	# so since tlkt.scd is t2 t1 then msa must be t2 t1
print INFX "done\n"   ;
print INFX "LAMBDA=`grep \'Lambda =\' msa2d_test.txt | sed \"s/=/= /g\" | awk \' /Lambda = / { ++num }; {total += \$6}; {ave = total/num}; END {printf \"\%.2f\", ave}\'`\n"   ;
print INFX "echo \"Lambda determined to be \$LAMBDA\"\n"   ;
print INFX "if [ \$LAMBDA = \"0.00\" ]; then echo \'LAMBDA not defined. Aborting!\'; exit 1; fi\n"   ;
print INFX "LOOPS=`grep \'Loop\' msa2d_test.txt | awk \' \$2 > max {max=\$2}; END {print max}\'`\n"   ;
print INFX "if [ \"\$LOOPS\" = \"1400\" ]\n"   ;
print INFX "then\n"   ;
print INFX "  echo \'MSA2D did not converge in the correct number of loops. Aborting!\'\n"   ;
print INFX "  exit 1\n"   ;
print INFX "fi\n"   ;
print INFX "\n"   ;
print INFX "echo \'Cutting direct dimension in half prior to MSA calculation\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "LOAD f3_proc.sec\n"   ;
print INFX "DIM F3\n"   ;
	if ($HN == 1)
	{	
printf INFX "SHRINK %i 1\n", $shnum   ;
	}
print INFX "SAVE f3_proc.sec\n"   ;
print INFX "EOF\n"   ;
print INFX "\n"   ;
print INFX "section -d\n"   ;
printf INFX "section -c %i %i %i\n", $maxvp_ft*2, $maxvc_ft*2,  $numprocs*2  ;
print INFX "\n"   ;
print INFX "echo \'Creating MSA2D parameter file with constant Lambda for final MSA2D calculation\'\n"   ;
print INFX "echo \'DEBUG 2\' >> msa2d_param\n"   ;
print INFX "echo \'NLOOPS 1400\' >> msa2d_param\n"   ;
print INFX "echo \"DEF \$DEF_LAST_FID\" >> msa2d_param\n"   ;
print INFX "echo \"LAMBDA \$LAMBDA\" >> msa2d_param\n"   ;
print INFX "echo \'SCALEFIRST 0.5\' >> msa2d_param\n"   ;
print INFX "echo \'SCHED ./tlkt.scd\' >> msa2d_param\n"   ;
printf INFX "echo \'NOUT %i %i\' >> msa2d_param\n" , $maxvp_ft, $maxvc_ft;	# see above for dimensions order (first iteration)
print INFX "echo \'PHASE 0.0 0.0 0.0 0.0\' >> msa2d_param\n"   ;
print INFX "echo \'LW 0.0 0.0\' >> msa2d_param\n"   ;
print INFX "echo \'JVALUE 0.0 0.0\' >> msa2d_param\n"   ;
print INFX "sleep 1\n"   ;
print INFX "\n"   ;
print INFX "echo \'Data will be processed as 2D chunks to reduce memory requirements\'\n"   ;
print INFX "if [ -d tmp_chunks ]; then rm -r tmp_chunks; fi\n"   ;
print INFX "mkdir tmp_chunks\n"   ;
print INFX "i=1\n"   ;
print INFX "j=1\n"   ;
printf INFX "while [ \${j} -lt %i ]\n", ($shnum/$numprocs)+1   ;
print INFX "do\n"   ;
print INFX "  echo \'\'\n"   ;
printf INFX "  echo \"Chunk: \${j} of %i \"\n", ($shnum/$numprocs)  ;
print INFX "  echo \"MSA2D calculation running with DEF = \$DEF_LAST_FID, LAMBDA = \$LAMBDA\"\n"   ;
printf INFX "  rnmrtk LOAD f3_proc.sec dim f3 t1 t2 num %i start \${i}\n", $numprocs   ;
print INFX "  msa2d t2 t1 ./msa2d_param >> msa2d.txt\n"   ;
print INFX "  rnmrtk dim 1 realpart \n"   ;
print INFX "  rnmrtk dim 2 realpart \n"   ;
print INFX "  rnmrtk dim 3 realpart \n"   ;
print INFX "  rnmrtk SAVE tmp_chunks/chunk\${j}.sec\n"   ;
printf INFX "  i=\$((\${i}+%i))\n",$numprocs   ;
print INFX "  j=\$((\${j}+1))\n"   ;
print INFX "done\n"   ;
print INFX "\n"   ;
print INFX "\n"   ;
print INFX "section -d\n"   ;
if ($maxvp_ft*$maxvc_ft*$shnum > $maxmemsize )
{
print "WARNING THE PROCESSING SCRIPT PRODUCED WILL NOT HAVE ENOUGH MEMORY AVAILABEL FOR AUTOMATIC PROCESSING OF THIS DATA, TRY ONE OF THE FOLLOWING!"	;
print "1.MAKE SURE THE SYSTEM SETTINGS AT THE TOP OF GENPROC.PRL ARE SET APPROPRIATELY."	;
print "2.USE A COMPUTER WITH MORE AVAILABLE DATA FOR SHARED MEMORY SECTION."	;
print "3.MODIFY THE OUTPUT TO CREATE A SMALLER DATASIZE (I.E. BY CHANGING NPTS IN ONE OF THE DIMENSIONS)."	;
}
printf INFX "section -c %i %i %i\n", $maxvp_ft, $maxvc_ft, $shnum;
print INFX "\n"   ;
print INFX "echo \'Saving MSA2D data from individual planes into single Rowland NMRToolkit file\'\n"   ;
print INFX "if [ -e temp.sec ]; then rm temp.sec; fi\n"   ;
print INFX "if [ -e combine.sh ]; then rm combine.sh; fi\n"   ;
print INFX "if [ -e combine.log ]; then rm combine.log; fi\n"   ;
print INFX "touch temp.sec combine.sh\n"   ;
print INFX "echo \'i=\$1\' >> combine.sh\n"   ;
print INFX "echo \'rnmrtk << EOF\' >> combine.sh\n"   ;
print INFX "echo \'LOAD tmp_chunks/chunk\${i}.sec\' >> combine.sh \n"   ;
if ($flag == 0 || $flag == 2) {
print INFX "echo \'DIM f2\' >> combine.sh\n"   ;
print INFX "echo \'REVERSE\' >> combine.sh\n"   ;
	if($pp =~ 'hbhaconh' )
	{
	printf INFX "echo \'ROTATE %i\' >> combine.sh\n", $maxvp_ft/2.0; # vp is first indirect dimension and vc is second (t2 t1 in this case) 
	$o1_2=$o1_2-($swp_2/2.0);
	print INFX "echo \'REVERSE\' >> combine.sh\n"   ;

	printf INFX "echo \'SETPAR PPM2 %9.3f\' >> combine.sh\n", $o1_2 ;

	}
}
if ($flag == 0 || $flag == 1) {
print INFX "echo \'DIM f1\' >> combine.sh\n"   ;
print INFX "echo \'REVERSE\' >> combine.sh\n"   ;
	if($pp =~ 'hbhaconh' )
	{
	printf INFX "echo \'ROTATE %i\' >> combine.sh\n", $maxvc_ft/2.0; # vp is first indirect dimension and vc is second (t2 t1 in this case) 
	$o1_3=$o1_3-($swp_3/2.0);
	printf INFX "echo \'SETPAR PPM1 %9.3f\' >> combine.sh\n", $o1_3 ;
	
	}
}

print INFX "echo \'APPEND temp.sec\' >> combine.sh\n"   ;
print INFX "echo \'EOF\' >> combine.sh\n"   ;
print INFX "sleep 1\n"   ;
print INFX "j=1\n"   ;
printf INFX "while [ \${j} -lt %i ]\n", ($shnum/$numprocs)+1   ;
print INFX "do\n"   ;
print INFX "  sh ./combine.sh \${j} >> combine.log\n"   ;
print INFX "  j=\$((\${j}+1))\n"   ;
print INFX "done\n"   ;
print INFX "rm -r tmp_chunks\n"   ;
print INFX "rnmrtk LOAD temp.sec f1 f2 f3\n"   ;
print INFX "\n"   ;
printf INFX "echo \'Saving final data in NMRPipe format as %s.ft3\'\n", $pp   ;
print INFX "echo \'If the file exists it will be overwritten!\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
printf INFX "PUTNMRPIPE %s_f3f2.ft3 f3 f1\n", $pp   ;
printf INFX "PUTXEASY %s. other\n", $pp   ;
printf INFX "load temp.sec\n"   ;
printf INFX "dim 2 xsect sum\n"   ;
printf INFX "putnmrpipe f2_proj.ft2\n"   ;
printf INFX "load temp.sec\n"   ;
printf INFX "dim 1 xsect sum\n"   ;
printf INFX "putnmrpipe f1_proj.ft2\n"   ;
print INFX "EOF\n"   ;
print INFX "\n"   ;
print INFX "echo \'Removing shared memory section\'\n"   ;
print INFX "section -d\n"   ;
print INFX "\n"   ;
print INFX "echo \'Examining output from MSA2D calculation for convergence. Please be patient!\'\n"   ;
print INFX "LOOPS=`grep \'Loop\' msa2d.txt | sort -n -k 2 | awk \' {loops = \$2}; END {print loops}\'`\n"   ;
print INFX "echo \"The largest number of loops to achieve convergence in msa2d.txt is \$LOOPS\"\n"   ;
print INFX "if [ \"\$LOOPS\" = \"1400\" ]\n"   ;
print INFX "then\n"   ;
print INFX "  echo \'MSA2D did not converge in the correct number of loops\'\n"   ;
print INFX "fi\n"   ;
print INFX "\n"   ;
print INFX "echo \"Initial MSA2D calculation was performed with DEF = \$DEF_LAST_FID and AIM = \$AIM_LAST_FID with constant AIM\"\n"   ;
print INFX "echo \"to determine LAMBDA. Final MSA2D calculation performed with DEF = \$DEF_LAST_FID and LAMBDA = \$LAMBDA\"\n"   ;
print INFX "\n"   ;
print INFX "echo \'Remove comments to clean up intermediate files.\'\n"   ;
print INFX "rm time_3d.sec time_3d.par f3_proc.sec f3_proc.par\n"   ;
print INFX "rm msa2d_test.txt msa2d_test_param noisecalc1.txt noisecalc2.txt load_noisecalc.sh combine.sh combine.log\n"   ;
print INFX "\n"   ;
}

#------------------------------------------------------------------------------------------
#*************************** CREATE PROCESSING SCRIPT FOR 4D ******************************
sub printproc2
{
$file2 = "proc_4d.com";
open(INFX, ">$file2") || die "Can't open output file";

print INFX "\#! /bin/sh\n"   ;
print INFX "\n"   ;
#print INFX "echo \"Creating a shared memory section of \$mem_size Mbytes\"\n"   ;
printf INFX "section -c %i %i 2\n", $ni_h*4,  $nlin_3d*8+1  ;
print INFX "\n"   ;
print INFX "echo \'Creating a parameter file for Bruker format and importing data\'\n"   ;
print INFX "if [ -e ser.par ]; then rm ser.par; fi\n"   ;
print INFX "if [ -e ser.dat ]; then mv ser.dat ser.dat.orig; fi\n"   ;
print INFX "if [ -e ser ]; then cp ser ser.dat; else echo \'File ser does not exist! Exiting!\'; exit 1; fi\n"   ;
printf INFX "echo \'Format     %s     int-32\' >> ser.par\n", $bo   ;
print INFX "echo \'DOM     t1     t2     t3   t4 \' >> ser.par\n"   ;
printf INFX "echo \"N     %i C     1 C     1 C  %i C   \" >> ser.par\n", $nlin_3d, $ni_h   ;
printf INFX "echo \'SW    %9.3f %9.3f %9.3f %9.3f \' >> ser.par\n", $sw_4, $sw_3, $sw_2, $sw_h   ;
printf INFX "echo \'SF     %9.3f %9.3f %9.3f %9.3f \' >> ser.par\n" , $sw_4/$swp_4, $sw_3/$swp_3, $sw_2/$swp_2, $sw_h/$swp_h    ;
printf INFX "echo \'PPM      %9.3f %9.3f %9.3f %9.3f\' >> ser.par\n", $o1_4, $o1_3, $o1_2, $o1_h  ;
print INFX "echo \'QUAD     STATES-TPPI     STATES-TPPI   STATES-TPPI   STATES\' >> ser.par\n"   ;
printf INFX "echo \"LAYOUT T1:%i T2:2 T3:2 T4:%i\" >> ser.par\n", $nlin_3d*2, $ni_h*2   ;
print INFX "rnmrtk LOAD ser.dat\n"   ;
print INFX "rnmrtk SEEPAR\n"   ;
print INFX "rm ser.dat\n"   ;
print INFX "\n"   ;
print INFX "\n"   ;
# $numflag is 1 when ni_h is a fourier number, numflag is 0 when it isn't
$numft=$fnumft=$cnumft=$numflag=$nzftnum=0;
&findftnum($maxvc, $numft, $fnumft, $cnumft, $numflag, $nzftnum);
#$maxvc_ft=$nzftnum*2;
$maxvc_ft=$nzftnum*4;
#increase resolution in proton by default
$numft=$fnumft=$cnumft=$numflag=$nzftnum=0;
&findftnum($maxvp, $numft, $fnumft, $cnumft, $numflag, $nzftnum);
$maxvp_ft=$nzftnum*2;
$numft=$fnumft=$cnumft=$numflag=$nzftnum=0;
&findftnum($maxva, $numft, $fnumft, $cnumft, $numflag, $nzftnum);
$maxva_ft=$nzftnum*2;
$numft=$fnumft=$cnumft=$numflag=$nzftnum=0;


if ($maxvc_ft > 512 && $maxvc < 512)
{
	$maxvc_ft=256
}
if ($maxvp_ft > 256 && $maxvp < 256)
{
	$maxvp_ft=256
}
if ($maxva_ft > 256 && $maxva < 256)
{
	$maxva_ft=256
}


#VA IS NITROGEN, VP IS CARBON, VC IS PROTON
#printf "%i %i\n", $maxvc, $maxvp;
&findftnum($ni_h, $numft, $fnumft, $cnumft, $numflag, $nzftnum);
$shnum=$ni_h/2;
if ($numflag != 1)
{
$shnum=$nzftnum;
}


print INFX "echo \'Saving time domain data and setting parameters\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "COM \'Taking the complex conjugate of the acquisition dimension to reverse spectra\'\n"   ;
print INFX "DIM t4\n"   ;
print INFX "CONJ\n"   ;
print INFX "COM \'Saving time domain data as time_3d.sec\'\n"   ;
print INFX "SAVE time_3d.sec\n"   ;
print INFX "SEEPAR\n"   ;
print INFX "EOF\n"   ;
print INFX "\n"   ;
print INFX "\n"   ;
print INFX "echo \'Starting t3 fourier transformation of 3D data set for noisecalc\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "DIM t4\n"   ;
print INFX "FFT 1.0\n"   ;
printf INFX "PHASE %9.3f %9.3f\n", $ph0, $ph1   ;
printf INFX "PHASE %9.3f %9.3f\n", $inphase0, $inphase1 ;
print INFX "IFFT 1.0\n"   ;

if ($HN != 5)
{
	print INFX "SSTDC 8 20 0.00\n"   ;
}
print INFX "BC 12.5\n"   ;
print INFX "GM 10.00 10.00\n"   ;
#printf INFX "ZEROFILL \n";  # need something to make sure this doesnt' go crazy

if ($numflag==3)
	{
printf INFX "ZEROFILL \n";		# zerofill twice if the number points is not a fourier number and is near the next fourier number
	}

print INFX "FFT 1.0\n"   ;
print INFX "COM \'Saving f3 processed data as noisecalc.sec\'\n"   ;
print INFX "SAVE noisecalc.sec\n"   ;
print INFX "SEEPAR\n"   ;
print INFX "EOF\n"   ;
print INFX "if [ -e noisecalc1.txt ]; then rm noisecalc1.txt; fi\n"   ;
print INFX "if [ -e noisecalc2.txt ]; then rm noisecalc2.txt; fi\n"   ;
print INFX "echo \'Determining Def and Aim based on noise in last FID or separate noise spectrum (noisecalc1.txt) and\'\n"   ;
print INFX "echo \'Finding the 10 largest signals outside the central region (noisecalc2.txt)\'\n"   ;
print INFX "if [ -e load_noisecalc.sh ]; then rm load_noisecalc.sh; fi\n"   ;
print INFX "echo \'i=\$1\' >> load_noisecalc.sh\n"   ;
print INFX "echo \'rnmrtk << EOF\' >> load_noisecalc.sh\n"   ;
print INFX "echo \'LOAD noisecalc.sec\' >> load_noisecalc.sh\n"   ;
print INFX "echo \'DIM t3\' >> load_noisecalc.sh\n"   ;
print INFX "echo \'SHRINK 1 \${i}\' >> load_noisecalc.sh\n"   ;
print INFX "echo \'SETPAR DOM F1\' >> load_noisecalc.sh\n"   ;
print INFX "echo \'EOF\' >> load_noisecalc.sh\n"   ;
#print INFX "sleep 1\n"   ;
printf INFX "sh ./load_noisecalc.sh %i \n", $nlin_3d   ;
#noisecalc noise percent, nih, ni collected in dim2, ni collected in dim3-if nus then this is often 1, npts after zf in dim2, dim3, dimension number where directect dimension lies for 1d this is simply 1 
printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 noisecalc1.txt\n", $ni_h, $nlin_3d, $maxvc_ft*$maxvp_ft*$maxva_ft, 1 ;
print INFX "sh ./load_noisecalc.sh 1 \n"   ;	# defaults to first fid but could be changed for HNCACB and COSY type spectra.
printf INFX "noisecalc 20.0 %i %i 1 %i %i 1 noisecalc2.txt\n", $ni_h, $nlin_3d, $maxvc_ft*$maxvp_ft*$maxva_ft, 1 ;
print INFX "\n"   ;
print INFX "echo \'Starting t3 fourier transformation of 3D data set\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "LOAD time_3d.sec\n"   ;
print INFX "DIM t4\n";
print INFX "FFT 1.0\n"   ;
printf INFX "PHASE %9.3f %9.3f\n", $ph0, $ph1   ;
printf INFX "PHASE %9.3f %9.3f\n", $inphase0, $inphase1 ;
print INFX "IFFT 1.0\n"   ;

if ($flag == 1) {
print INFX "SEFIX1 t1 \n";
}
if ($HN != 5)
{
	print INFX "SSTDC 8 20 0.00\n"   ;
}
print INFX "BC 12.5\n"   ;
print INFX "GM 10.00 10.00\n"   ;
#printf INFX "ZEROFILL \n";

if ($numflag==3)
	{
printf INFX "ZEROFILL \n";		# zerofill twice if the number of points is not a fourier number and is near the next fourier number
	};
print INFX "FFT 1.0\n"   ;
print INFX "COM \'Shrinking data will occur after Lambda is determined\'\n"   ;
print INFX "REALPART\n"   ;
print INFX "COM \'Saving f4 processed data as f4_proc.sec\'\n"   ;
print INFX "SAVE f4_proc.sec\n"   ;
print INFX "SEEPAR\n"   ;
print INFX "EOF\n"   ;
print INFX "\n"   ;
printf INFX "export MP_SET_NUMTHREADS=%i\n", $numprocs   ;
print INFX "echo \'Determining DEF and AIM values based on noise in last FID\'\n"   ;
print INFX "if [ -e msa3d_test.txt ]; then rm msa3d_test.txt; fi\n"   ;
print INFX "if [ -e msa3d.txt ]; then rm msa3d.txt; fi\n"   ;
print INFX "AIM_LAST_FID=`grep \'AIM for first indirect dimension\' noisecalc1.txt | awk \' {aim = \$7}; END {printf \"\%.2f\", aim} \'`\n"   ;
print INFX "DEF_LAST_FID=`grep \'DEF for first indirect dimension\' noisecalc1.txt | awk \' {def = \$7}; END {printf \"\%.2f\", def} \'`\n"   ;
print INFX "echo \"AIM_LAST_FID = \$AIM_LAST_FID\"\n"   ;
print INFX "echo \"DEF_LAST_FID = \$DEF_LAST_FID\"\n"   ;
print INFX "if [ \$AIM_LAST_FID = \"0.00\" ]; then echo \'AIM_LAST_FID not defined. Aborting!\'; exit 1; fi\n"   ;
print INFX "if [ \$DEF_LAST_FID = \"0.00\" ]; then echo \'DEF_LAST_FID not defined. Aborting!\'; exit 1; fi\n"   ;
print INFX "\n"   ;
print INFX "echo \'Creating a test MSA2D parameter file to determine LAMBDA\'\n"   ;
print INFX "if [ -e msa3d_test_param ]; then rm msa3d_test_param; fi\n"   ;
print INFX "if [ -e msa3d_param ]; then rm msa3d_param; fi\n"   ;
print INFX "touch msa3d_test_param msa3d_param\n"   ;
print INFX "echo \'DEBUG 2\' >> msa3d_test_param\n"   ;
print INFX "echo \'NLOOPS 1400\' >> msa3d_test_param\n"   ;
print INFX "echo \"DEF \$DEF_LAST_FID\" >> msa3d_test_param\n"   ;
print INFX "echo \"AIM \$AIM_LAST_FID\" >> msa3d_test_param\n"   ;
print INFX "echo \'SCALEFIRST 0.5\' >> msa3d_test_param\n"   ;
print INFX "echo \'SCHED ./tlkt.scd\' >> msa3d_test_param\n"   ;
printf INFX "echo \'NOUT %i %i %i \' >> msa3d_test_param\n" , $maxva_ft, $maxvp_ft, $maxvc_ft;
print INFX "echo \'PHASE 0.0 0.0 0.0 0.0\' >> msa3d_test_param\n"   ;
print INFX "echo \'LW 0.0 0.0\' >> msa3d_test_param\n"   ;
print INFX "echo \'JVALUE 0.0 0.0\' >> msa3d_test_param\n"   ;
print INFX "sleep 1\n"   ;
print INFX "\n"   ;
print INFX "echo \'Running MSA3D calculation for 10 planes with highest intensity to determine LAMBDA\'\n"   ;
print INFX "echo \'Capturing the result as msa3d_test.txt. Please be patient!\'\n"   ;
print INFX "i=0\n"   ;
print INFX "j=0\n"   ;
print INFX "while [ \${i} -lt 10 ]\n"   ;
print INFX "do\n"   ;
print INFX "  j=\$((\${i}+8))\n"   ;
print INFX "  i=\$((\${i}+1))\n"   ;
print INFX "  PLANE=`grep \'Highest peak amplitued points outside central region\' noisecalc2.txt | awk -v col=\"\$j\" \' {column = \$col}; END {printf \"\%.0f\", column} \'`\n"   ;
print INFX "  echo \"Loading plane \$i of 10, Plane number \$PLANE\"\n"   ;
print INFX "  rnmrtk LOAD f4_proc.sec dim f4 t1 t2 t3 num 1 start \$PLANE\n"   ;
print INFX "  msa3d t3 t2 t1 ./msa3d_test_param >> msa3d_test.txt\n"   ;
print INFX "done\n"   ;
print INFX "LAMBDA=`grep \'Lambda =\' msa3d_test.txt | sed \"s/=/= /g\" | awk \' /Lambda = / { ++num }; {total += \$6}; {ave = total/num}; END {printf \"\%.2f\", ave}\'`\n"   ;
print INFX "echo \"Lambda determined to be \$LAMBDA\"\n"   ;
print INFX "if [ \$LAMBDA = \"0.00\" ]; then echo \'LAMBDA not defined. Aborting!\'; exit 1; fi\n"   ;
print INFX "LOOPS=`grep \'Loop\' msa3d_test.txt | awk \' \$2 > max {max=\$2}; END {print max}\'`\n"   ;
print INFX "if [ \"\$LOOPS\" = \"1400\" ]\n"   ;
print INFX "then\n"   ;
print INFX "  echo \'MSA3D did not converge in the correct number of loops. Aborting!\'\n"   ;
print INFX "  exit 1\n"   ;
print INFX "fi\n"   ;
print INFX "\n"   ;
print INFX "  echo \'PLEASE USE SPLITPROC SCRIPT TO GENERATE APPROPRIATE SCRIPTS FOR PROCESSING!\'\n"   ;

# EVERYTHING PAST THIS POINT DOESNT REALLY GET RUN BECAUSE OF ISSUES WITH MEMORY SO WILL COMMENT IT OUT
#print INFX "echo \'Cutting direct dimension if appropriate prior to MSA calculation\'\n"   ;
#print INFX "rnmrtk << EOF\n"   ;
#print INFX "LOAD f4_proc.sec\n"   ;
#print INFX "DIM F4\n"   ;
#	if ($HN == 1)
#	{	
#printf INFX "SHRINK %i 1\n", $shnum   ;
#	}
#
#print INFX "SAVE f4_proc.sec\n"   ;
#print INFX "EOF\n"   ;
#print INFX "\n"   ;
#print INFX "section -d\n"   ;
#printf INFX "section -c %i %i %i %i\n", $maxvp_ft*2, $maxvc_ft*2, $maxva_ft*2, $numprocs*2  ;
#print INFX "\n"   ;
#print INFX "echo \'Creating MSA3D parameter file with constant Lambda for final MSA3D calculation\'\n"   ;
#print INFX "echo \'DEBUG 2\' >> msa3d_param\n"   ;
#print INFX "echo \'NLOOPS 350\' >> msa3d_param\n"   ;
#print INFX "echo \"DEF \$DEF_LAST_FID\" >> msa3d_param\n"   ;
#print INFX "echo \"LAMBDA \$LAMBDA\" >> msa3d_param\n"   ;
#print INFX "echo \'SCALEFIRST 0.5\' >> msa3d_param\n"   ;
#print INFX "echo \'SCHED ./tlkt.scd\' >> msa3d_param\n"   ;
#printf INFX "echo \'NOUT %i %i %i\' >> msa3d_param\n" , $maxva_ft, $maxvp_ft, $maxvc_ft;
#print INFX "echo \'PHASE 0.0 0.0 0.0 0.0\' >> msa3d_param\n"   ;
#print INFX "echo \'LW 0.0 0.0\' >> msa3d_param\n"   ;
#print INFX "echo \'JVALUE 0.0 0.0\' >> msa3d_param\n"   ;
#print INFX "sleep 1\n"   ;
#print INFX "\n"   ;
#print INFX "echo \'Data will be processed as 3D chunks to reduce memory requirements\'\n"   ;
#print INFX "if [ -d tmp_chunks ]; then rm -r tmp_chunks; fi\n"   ;
#print INFX "mkdir tmp_chunks\n"   ;
#print INFX "i=1\n"   ;
#print INFX "j=1\n"   ;
#printf INFX "while [ \${j} -lt %i ]\n", ($shnum/$numprocs)+1   ;
#print INFX "do\n"   ;
#print INFX "  echo \'\'\n"   ;
#printf INFX "  echo \"Chunk: \${j} of %i \"\n", ($shnum/$numprocs)  ;
#print INFX "  echo \"MSA2D calculation running with DEF = \$DEF_LAST_FID, LAMBDA = \$LAMBDA\"\n"   ;
#printf INFX "  rnmrtk LOAD f4_proc.sec dim f4 t1 t2 t3 num %i start \${i}\n", $numprocs   ;
#print INFX "  msa3d t3 t2 t1 ./msa3d_param >> msa3d.txt\n"   ;
#print INFX "  rnmrtk dim 1 realpart\n"   ;
#print INFX "  rnmrtk dim 2 realpart\n"   ;
#print INFX "  rnmrtk dim 3 realpart\n"   ;
#print INFX "  rnmrtk dim 4 realpart\n"   ;
#print INFX "  rnmrtk SAVE tmp_chunks/chunk\${j}.sec\n"   ;
#printf INFX "  i=\$((\${i}+%i))\n",$numprocs   ;
#print INFX "  j=\$((\${j}+1))\n"   ;
#print INFX "done\n"   ;
#print INFX "\n"   ;
#print INFX "\n"   ;
#print INFX "section -d\n"   ;
#if ($maxva_ft*$maxvp_ft*$maxvc_ft*$shnum > $maxmemsize)
#{
#print "WARNING THE PROCESSING SCRIPT PRODUCED WILL NOT HAVE ENOUGH MEMORY AVAILABEL FOR AUTOMATIC PROCESSING OF THIS DATA, TRY ONE OF THE FOLLOWING!"	;
#print "1.MAKE SURE THE SYSTEM SETTINGS AT THE TOP OF GENPROC.PRL ARE SET APPROPRIATELY."	;
#print "2.USE A COMPUTER WITH MORE AVAILABLE DATA FOR SHARED MEMORY SECTION."	;
#print "3.MODIFY THE OUTPUT TO CREATE A SMALLER DATASIZE (I.E. BY CHANGING NPTS IN ONE OF THE DIMENSIONS)."	;
#}
#printf INFX "section -c %i %i %i %i\n", $maxva_ft, $maxvp_ft, $maxvc_ft, $shnum;
#print INFX "\n"   ;
#print INFX "echo \'Saving MSA3D data from individual planes into single Rowland NMRToolkit file\'\n"   ;
#print INFX "if [ -e temp.sec ]; then rm temp.sec; fi\n"   ;
#print INFX "if [ -e combine.sh ]; then rm combine.sh; fi\n"   ;
#print INFX "if [ -e combine.log ]; then rm combine.log; fi\n"   ;
#print INFX "touch temp.sec combine.sh\n"   ;
#print INFX "echo \'i=\$1\' >> combine.sh\n"   ;
#print INFX "echo \'rnmrtk << EOF\' >> combine.sh\n"   ;
#print INFX "echo \'LOAD tmp_chunks/chunk\${i}.sec\' >> combine.sh \n"   ;
#print INFX "echo \'DIM f1\' >> combine.sh\n"   ;
#print INFX "echo \'REVERSE\' >> combine.sh\n"   ;
#print INFX "echo \'DIM f2\' >> combine.sh\n"   ;
#if ($flag != 2) {
#print INFX "echo \'REVERSE\' >> combine.sh\n"   ;
#}
#print INFX "echo \'DIM f3\' >> combine.sh\n"   ;
#print INFX "echo \'REVERSE\' >> combine.sh\n"   ;
#print INFX "echo \'APPEND temp.sec\' >> combine.sh\n"   ;
#print INFX "echo \'EOF\' >> combine.sh\n"   ;
#print INFX "sleep 1\n"   ;
#print INFX "j=1\n"   ;
#printf INFX "while [ \${j} -lt %i ]\n", ($shnum/$numprocs)+1   ;
#print INFX "do\n"   ;
#print INFX "  sh ./combine.sh \${j} >> combine.log\n"   ;
#print INFX "  j=\$((\${j}+1))\n"   ;
#print INFX "done\n"   ;
#print INFX "rm -r tmp_chunks\n"   ;
#print INFX "rnmrtk LOAD temp.sec\n"   ;
#print INFX "\n"   ;
#
#printf INFX "echo \'Saving final data in NMRPipe format as %s.ft3\'\n", $pp   ;
#print INFX "echo \'If the file exists it will be overwritten!\'\n"   ;
#print INFX "rnmrtk << EOF\n"   ;
#printf INFX "PUTNMRPIPE %s_f3f2.ft3 f4 f3 f2\n", $pp   ;
#print INFX "EOF\n"   ;
#print INFX "\n"   ;
#print INFX "echo \'Removing shared memory section\'\n"   ;
#print INFX "section -d\n"   ;
#print INFX "\n"   ;
#print INFX "echo \'Examining output from MSA3D calculation for convergence. Please be patient!\'\n"   ;
#print INFX "LOOPS=`grep \'Loop\' msa3d.txt | sort -n -k 2 | awk \' {loops = \$2}; END {print loops}\'`\n"   ;
#print INFX "echo \"The largest number of loops to achieve convergence in msa3d.txt is \$LOOPS\"\n"   ;
#print INFX "if [ \"\$LOOPS\" = \"350\" ]\n"   ;
#print INFX "then\n"   ;
#print INFX "  echo \'MSA3D did not converge in the correct number of loops\'\n"   ;
#print INFX "fi\n"   ;
#print INFX "\n"   ;
#print INFX "echo \"Initial MSA3D calculation was performed with DEF = \$DEF_LAST_FID and AIM = \$AIM_LAST_FID with constant AIM\"\n"   ;
#print INFX "echo \"to determine LAMBDA. Final MSA3D calculation performed with DEF = \$DEF_LAST_FID and LAMBDA = \$LAMBDA\"\n"   ;
#print INFX "\n"   ;
#print INFX "echo \'Remove comments to clean up intermediate files.\'\n"   ;
#print INFX "rm time_3d.sec time_3d.par f3_proc.sec f3_proc.par\n"   ;
#print INFX "rm msa2d_test.txt msa2d_test_param noisecalc1.txt noisecalc2.txt load_noisecalc.sh combine.sh combine.log\n"   ;
#print INFX "\n"   ;
}

#*************************** CREATE PROCESSING SCRIPT FOR 2D ******************************
sub print2d
{
$file2 = "proc_2d.com", $pp;
open(INFX, ">$file2") || die "Can't open output file";


print INFX "\#! /bin/sh\n"   ;
print INFX "\n"   ;
printf INFX "section -c %i %i 2\n", $ni_h*4,  $nlin_1d*2+1  ;
print INFX "\n"   ;
print INFX "echo \'Creating a parameter file for Bruker format and importing data\'\n"   ;
print INFX "if [ -e ser.par ]\; then rm ser.par\; fi\n"   ;
print INFX "if [ -e ser.dat ]\; then mv ser.dat ser.dat.orig\; fi\n"   ;
print INFX "if [ -e ser ]\; then cp ser ser.dat\; else echo \'File ser does not exist! Exiting!\'\; exit 1\; fi\n"   ;
printf INFX "echo \'Format     $bo    int-32\' >> ser.par\n", $bo   ;
print INFX "echo \'DOM     t1     t2\' >> ser.par\n"   ;
printf INFX "echo \"N     %i C     %i C\" >> ser.par\n", $nlin_1d, $ni_h   ;
printf INFX "echo \'SW      %9.3f %9.3f  \' >> ser.par\n", $sw_2, $sw_h   ;
printf INFX "echo \'SF      %9.3f %9.3f  \' >> ser.par\n", $sw_2/$swp_2, $sw_h/$swp_h   ;
printf INFX "echo \'PPM     %9.3f %9.3f  \' >> ser.par\n", $o1_2, $o1_h    ;
print INFX "echo \'QUAD     STATES-TPPI     STATES\' >> ser.par\n"   ;
printf INFX "echo \"LAYOUT T1:%i T2:%i\" >> ser.par\n", $nlin_1d*2, $ni_h*2   ;

# $numflag is 1 when ni_h is a fourier number, numflag is 0 when it isn't
$numft=$fnumft=$cnumft=$numflag=$nzftnum=0;
&findftnum($maxvd, $numft,$fnumft, $cnumft, $numflag, $nzftnum);
$maxvd_ft=$nzftnum*2;
$numft=$fnumft=$cnumft=$numflag=$nzftnum=0;
#Vd NITROGEN
&findftnum($ni_h, $numft, $fnumft, $cnumft, $numflag, $nzftnum);
$shnum=$nzftnum;

if ($HR == 2)
{
	$maxvd_ft = $maxvd_ft*2;		
}
if ($HR == 3)
{
	$maxvd_ft = $maxvd_ft*4;		
}
if ($HR == 4)
{
	$maxvd_ft = $maxvd_ft*8;		
}


print INFX "rnmrtk LOAD ser.dat\n"   ;
print INFX "rnmrtk SEEPAR\n"   ;
print INFX "rm ser.dat\n"   ;
print INFX "\n"   ;
print INFX "\n"   ;
print INFX "echo \'Saving time domain data and setting parameters\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "COM \'Taking the complex conjugate of the acquisition dimension to reverse spectra\'\n"   ;
print INFX "DIM t2\n"   ;
print INFX "CONJ\n"   ;
	if($pp =~ 'hs15n_wtgs_nl.n')
	{
print INFX "DIM t1\n"   ;
print INFX "QUADFIX R I -R -I\n"   ;
	}
print INFX "COM \'Eliminating intial points in Bruker digital filtered data\'\n"   ;


print INFX "COM \'Saving time domain data as time_2d.sec\'\n"   ;
print INFX "SAVE time_2d.sec\n"   ;
print INFX "SEEPAR\n"   ;
print INFX "EOF\n"   ;
print INFX "\n"   ;
print INFX "\n"   ;
print INFX "echo \'Starting t2 fourier transformation of 2D data set\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "DIM t2\n"   ;
print INFX "FFT 1.0\n"   ;
printf INFX "PHASE %9.3f %9.3f\n", $ph0, $ph1   ;
printf INFX "PHASE %9.3f %9.3f\n", $inphase0, $inphase1 ;
print INFX "IFFT 1.0\n"   ;

if ($HN != 5)
{
	print INFX "SSTDC 8 20 0.00\n"   ;
}
print INFX "BC 12.5\n"   ;
print INFX "GM 20.00 20.00\n"   ;
print INFX "ZEROFILL \n";

if ($numflag==3)
	{
printf INFX "ZEROFILL \n";		# zerofill twice if the number points is not a fourier number and is near the next fourier number
	}
print INFX "FFT 1.0\n"   ;
print INFX "COM \'Saving f2 processed data as noisecalc.sec\'\n"   ;
print INFX "SAVE noisecalc.sec\n"   ;
print INFX "SEEPAR\n"   ;
print INFX "EOF\n"   ;
print INFX "if [ -e noisecalc1.txt ]\; then rm noisecalc1.txt\; fi\n"   ;
print INFX "if [ -e noisecalc2.txt ]\; then rm noisecalc2.txt\; fi\n"   ;
print INFX "echo \'Determining Def and Aim based on noise in last FID or separate noise spectrum (noisecalc1.txt) and\'\n"   ;
print INFX "echo \'Finding the 10 largest signals outside the central region (noisecalc2.txt)\'\n"   ;
printf INFX "rnmrtk LOAD noisecalc.sec START %i NUM 1\n", $nlin_1d   ;
if ($sens == 1)
{
			printf INFX "noisecalc 20.0 %i %i 1 %i 1 2 noisecalc1.txt\n", $ni_h, $nlin_1d, $maxvd_ft ;
}elsif ($sens==2){	printf INFX "noisecalc 20.0 %i %i 1 %i 1 2 noisecalc1.txt\n", $ni_h, $nlin_1d, $maxvd_ft*4 ;
}elsif ($sens==3){	printf INFX "noisecalc 20.0 %i %i 1 %i 1 2 noisecalc1.txt\n", $ni_h, $nlin_1d, $maxvd_ft*8 ;
}elsif ($sens==4){	printf INFX "noisecalc 20.0 %i %i 1 %i 1 2 noisecalc1.txt\n", $ni_h, $nlin_1d, $maxvd_ft*0.1 ;

}

print INFX "rnmrtk LOAD noisecalc.sec START 1 NUM 1\n"   ;

if ($sens == 1)
{
			printf INFX "noisecalc 20.0 %i %i 1 %i 1 2 noisecalc2.txt\n", $ni_h, $nlin_1d, $maxvd_ft ;
}elsif ($sens==2){	printf INFX "noisecalc 20.0 %i %i 1 %i 1 2 noisecalc2.txt\n", $ni_h, $nlin_1d, $maxvd_ft*4 ;
}elsif ($sens==3){	printf INFX "noisecalc 20.0 %i %i 1 %i 1 2 noisecalc2.txt\n", $ni_h, $nlin_1d, $maxvd_ft*8 ;
}elsif ($sens==4){	printf INFX "noisecalc 20.0 %i %i 1 %i 1 2 noisecalc2.txt\n", $ni_h, $nlin_1d, $maxvd_ft*0.1 ;

}
print INFX "\n"   ;
print INFX "echo \'Starting t2 fourier transformation of 2D data set\'\n"   ;
printf INFX "section -c %i %i\n", $ni_h*2,  $maxvd_ft*2  ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "LOAD time_2d.sec\n"   ;
print INFX "DIM t2\n"   ;
print INFX "FFT 1.0\n"   ;
printf INFX "PHASE %9.3f %9.3f\n", $ph0, $ph1   ;
printf INFX "PHASE %9.3f %9.3f\n", $inphase0, $inphase1 ;
print INFX "IFFT 1.0\n"   ;

if ($HN != 5)
{
	print INFX "SSTDC 8 20 0.00\n"   ;
}
print INFX "BC 12.5\n"   ;
print INFX "GM 20.00 20.00\n"   ;
printf INFX "ZEROFILL \n";

if ($numflag==3)
	{
printf INFX "ZEROFILL \n";		# zerofill twice if the number points is not a fourier number and is near the next fourier number
	}
print INFX "FFT 1.0\n"   ;
printf INFX "PHASE %f %f \n", $ph0, $ph1   ;
printf INFX "PHASE %9.3f %9.3f\n", $inphase0, $inphase1 ;
print INFX "REALPART\n"   ;
print INFX "COM \'Saving f2 processed data as f2_proc.sec\'\n"   ;
print INFX "SAVE f2_proc.sec\n"   ;
print INFX "SEEPAR\n"   ;
print INFX "EOF\n"   ;
print INFX "\n"   ;
print INFX "echo \'Starting Maximum Entropy Reconstruction for t1\'\n"   ;
print INFX "echo \'Determining DEF and AIM values based on noise in last FID\'\n"   ;
print INFX "if [ -e msa_test.txt ]\; then rm msa_test.txt\; fi\n"   ;
print INFX "if [ -e msa.txt ]\; then rm msa.txt\; fi\n"   ;
print INFX "AIM_LAST_FID=`grep \'AIM for first indirect dimension\' noisecalc1.txt | awk \' \{aim = \$7\}\; END \{printf \"\%.2f\", aim\} \'`\n"   ;
print INFX "DEF_LAST_FID=`grep \'DEF for first indirect dimension\' noisecalc1.txt | awk \' \{def = \$7\}\; END \{printf \"\%.2f\", def\} \'`\n"   ;
print INFX "echo \"AIM_LAST_FID = \$AIM_LAST_FID\"\n"   ;
print INFX "echo \"DEF_LAST_FID = \$DEF_LAST_FID\"\n"   ;
print INFX "if [ \$AIM_LAST_FID = \"0.00\" ]\; then echo \'AIM_LAST_FID not defined. Aborting!\'\; exit 1\; fi\n"   ;
print INFX "if [ \$DEF_LAST_FID = \"0.00\" ]\; then echo \'DEF_LAST_FID not defined. Aborting!\'\; exit 1\; fi\n"   ;
print INFX "echo \'Running MSA calculation for 10 columns with highest intensity to determine LAMBDA\'\n"   ;
print INFX "echo \'Capturing the result as msa_test.txt. Please be patient!\'\n"   ;
printf INFX "export MP_SET_NUMTHREADS=%i\n", $numprocs   ;

print INFX "rnmrtk << EOF\n"   ;
print INFX "DIM t1\n"   ;
printf INFX "ZEROFILL %i\n", $maxvd_ft   ;
print INFX "SAVE f2_proc.sec\n"   ;
print INFX "EOF\n"   ;
print INFX "i=0\n"   ;
print INFX "j=0\n"   ;
print INFX "while [ \$\{i\} -lt 10 ]\n"   ;
print INFX "do\n"   ;
print INFX "  j=\$((\$\{i\}+8))\n"   ;
print INFX "  i=\$((\$\{i\}+1))\n"   ;
print INFX "  COLUMN=`grep \'Highest peak amplitued points outside central region\' noisecalc2.txt | awk -v col=\"\$j\" \' \{column = \$col\}\; END \{printf \"\%.0f\", column\} \'`\n"   ;
print INFX "  echo \"Loading column \$i of 10, Column number \$COLUMN\"\n"   ;
print INFX "  rnmrtk LOAD f2_proc.sec dim t2 START \$COLUMN NUM 1\n"   ;
# if processing other data -180 must be removed
	if($pp =~ 'hs15n_wtgs_nl.n')
	{
print INFX "  msa t1 1400 ./tlkt.scd \$DEF_LAST_FID \$AIM_LAST_FID 0.00 0.0 -180.0 0.00 2 SINGLE >> msa_test.txt\n"   ;
	}else{
print INFX "  msa t1 1400 ./tlkt.scd \$DEF_LAST_FID \$AIM_LAST_FID 0.00 0.0 0.0 0.00 2 SINGLE >> msa_test.txt\n"   ;
	}

    print INFX "done\n"   ;
print INFX "LAMBDA_T1=`grep \'Chunk\' msa_test.txt | grep \'L =\' | sed \'s/=/= /g\' | awk \' /L =/ \{ ++num \}\; \{total += \$11\}\; \{ave = total/num\}\; END \{printf \"\%.2f\", ave\}\'`\n"   ;
print INFX "echo \"Lambda determined to be \$LAMBDA_T1\"\n"   ;
print INFX "if [ \$LAMBDA_T1 = \"0.00\" ]\; then echo \'LAMBDA_T1 not defined. Aborting!\'\; exit 1\; fi\n"   ;
print INFX "LOOPS1=`grep \'Loop\' msa_test.txt | awk \' \$4 > max \{max=\$4\}\; END \{print max\}\'`\n"   ;
print INFX "if [ \"\$LOOPS1\" = \"1400\" ]\n"   ;
print INFX "then\n"   ;
print INFX "  echo \'MSA did not converge in the correct number of loops. Aborting!\'\n"   ;
print INFX "  exit 1\n"   ;
print INFX "fi\n"   ;

print INFX "rnmrtk << EOF\n"   ;
print INFX "load f2_proc.sec\n"   ;
print INFX "dim 2\n"   ;
printf INFX "shrink %i 1\n", $shnum   ;
print INFX "EOF\n"   ;

print INFX "echo \'Running MSA calculation with calculated LAMBDA value and capturing the result as msa.txt. Please be patient!\'\n"   ;
	if($pp =~ 'hs15n_wtgs_nl.n')
	{
print INFX "msa t1 1400 ./tlkt.scd \$DEF_LAST_FID \$LAMBDA_T1 LAMBDA 0.00 0.0 -180.0 0.00 2 SINGLE >> msa.txt\n"   ;
    }else{
print INFX "msa t1 1400 ./tlkt.scd \$DEF_LAST_FID \$LAMBDA_T1 LAMBDA 0.00 0.0 0.0 0.00 2 SINGLE >> msa.txt\n"   ;
	}
print INFX "LOOPS2=`grep \'Loop\' msa.txt | awk \' \$4 > max \{max=\$4\}\; END \{print max\}\'`\n"   ;
print INFX "if [ \"\$LOOPS2\" = \"1400\" ]\n"   ;
print INFX "then\n"   ;
print INFX "  echo \'MSA did not converge in the correct number of loops. Aborting!\'\n"   ;
print INFX "  exit 1\n"   ;
print INFX "fi\n"   ;
print INFX "\n"   ;
print INFX "echo \'Saving final data in Rowland NMRToolkit format as hsqc.sec\'\n"   ;
print INFX "echo \'If the file exists it will be overwritten!\'\n"   ;
print INFX "if [ -e hsqc.sec ]\; then rm hsqc.sec\; fi\n"   ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "DIM f1\n"   ;
print INFX "REALPART\n"   ;
print INFX "reverse\n"   ;
printf INFX "SAVE %s.sec\n",$pp   ;
print INFX "EOF\n"   ;
print INFX "\n"   ;
print INFX "echo \'Saving final data in NMRPipe format as hsqc.ft2\'\n"   ;
print INFX "echo \'If the file exists it will be overwritten!\'\n"   ;
print INFX "if [ -e hsqc.ft2 ]\; then rm hsqc.ft2\; fi\n"   ;
print INFX "rnmrtk << EOF\n"   ;
printf INFX "PUTNMRPIPE %s.ft2\n",$pp   ;
print INFX "EOF\n"   ;
print INFX "\n"   ;
print INFX "echo \'Removing shared memory section\'\n"   ;
print INFX "section -d\n"   ;
print INFX "\n"   ;
print INFX "echo \'Cleaning up intermediate files.\'\n"   ;
print INFX "rm time_2d.sec time_2d.par f2_proc.sec f2_proc.par\n"   ;
print INFX "rm msa_test.txt noisecalc1.txt noisecalc2.txt noisecalc.sec noisecalc.par\n"   ;
print INFX "\n"   ;
}

#******************************** LINEAR PROCESSING OF 3D DATA  ************************
sub printproc_lin
{
$file2 = "proc_3d\_hr$HR.com";printf INFX "SEEPAR\n"   ;

open(INFX, ">$file2") || die "Can't open output file";

print INFX "\#! /bin/sh\n"   ;
print INFX "\n"   ;
#print INFX "echo \"Creating a shared memory section of \$mem_size Mbytes\"\n"   ;
printf INFX "section -c %i %i %i\n", $ni_h*2,  $ni_2*4+1, $ni_3*2  ;
print INFX "\n"   ;
print INFX "echo \'Creating a parameter file for Bruker format and importing data\'\n"   ;
print INFX "if [ -e ser.par ]; then rm ser.par; fi\n"   ;
print INFX "if [ -e ser.dat ]; then mv ser.dat ser.dat.orig; fi\n"   ;
print INFX "if [ -e ser ]; then cp ser ser.dat; else echo \'File ser does not exist! Exiting!\'; exit 1; fi\n"   ;
printf INFX "echo \'Format     %s     int-32\' >> ser.par\n", $bo   ;
print INFX "echo \'DOM     t1     t2     t3\' >> ser.par\n"   ;
printf INFX "echo \"N     %i C    %i C     %i C\" >> ser.par\n", $ni_3, $ni_2, $ni_h  ;
printf INFX "echo \'SW    %9.3f %9.3f %9.3f \' >> ser.par\n", $sw_3, $sw_2, $sw_h   ;
printf INFX "echo \'SF     %9.3f %9.3f %9.3f \' >> ser.par\n" , $sw_3/$swp_3, $sw_2/$swp_2, $sw_h/$swp_h    ;
printf INFX "echo \'PPM      %9.3f %9.3f %9.3f\' >> ser.par\n", $o1_3, $o1_2, $o1_h  ;
print INFX "echo \'QUAD     STATES-TPPI     STATES-TPPI     STATES\' >> ser.par\n"   ;
printf INFX "echo \"LAYOUT T1:%i T2:%i T3:%i\" >> ser.par\n", $ni_3*2, $ni_2*2, $ni_h*2   ; #gomp
# $numflag is 1 when ni_h is a fourier number, numflag is 0 when it isn't
$numft=$fnumft=$cnumft=$numflag=$nzftnum=0;
&findftnum($ni_3, $numft, $fnumft, $cnumft, $numflag, $nzftnum);
$ni_3_ft=$nzftnum*2;
$numft=$fnumft=$cnumft=$numflag=$nzftnum=0;
&findftnum($ni_2, $numft, $fnumft, $cnumft, $numflag, $nzftnum);
$ni_2_ft=$nzftnum*2;
$numft=$fnumft=$cnumft=$numflag=$nzftnum=0;

if ($ni_2_ft > 512 && $ni_2_ft < 512)
{
	$ni_2_ft=512
}
if ($ni_3_ft > 512 && $ni_3_ft < 512)
{
	$ni_3_ft=512
}

if ($HR == 2)
{
	$ni_2_ft = $ni_2_ft*2;
	$ni_3_ft = $ni_3_ft*2;		
}
if ($HR == 3)
{
	$ni_2_ft = $ni_2_ft*4;
	$ni_3_ft = $ni_3_ft*4;		
}
if ($HR == 4)
{
	$ni_2_ft = 512;
	$ni_3_ft = 512;		
}
#VC IS CARBON, VP IS NITROGEN
#printf "%i \n", $shnum;
&findftnum($ni_h, $numft, $fnumft, $cnumft, $numflag, $nzftnum);
$shnum=$nzftnum;
if ($HN!=1)
{
$shnum=$nzftnum*2;
}
#printf "%i %i\n", $shnum, $nzftnum;

#	maximum value allowed is 512 512 1024 (technically the value is 2^29-128
if ($ni_2_ft*$ni_3_ft*$shnum > 512*512*2047)	
	{
	printf "The maximum memory size which can be handeled by RNMRTK has been exceeded! \n";
	printf "The resulting script must be modified prior to use, or a smaller data size must be used! \n";
	
#	return;	
	}

printf INFX "section -c %i %i %i\n", $ni_2_ft*2,  $ni_3_ft*2, $ni_h*2  ;
print INFX "rnmrtk LOAD ser.dat\n"   ;
print INFX "rnmrtk SEEPAR\n"   ;
print INFX "rm ser.dat\n"   ;
print INFX "\n"   ;
print INFX "\n"   ;



print INFX "echo \'Saving time domain data and setting parameters\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "COM \'Taking the complex conjugate of the acquisition dimension to reverse spectra\'\n"   ;
print INFX "DIM t3\n"   ;
print INFX "CONJ\n"   ;
print INFX "DIM 1 QUADFIX R I -R -I\n";
print INFX "COM \'Saving time domain data as time_3d.sec\'\n"   ;
print INFX "SAVE time_3d.sec\n"   ;
print INFX "SEEPAR\n"   ;
print INFX "EOF\n"   ;
print INFX "echo \'Starting t3 fourier transformation of 3D data set\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "LOAD time_3d.sec\n"   ;
print INFX "DIM t3\n";
print INFX "FFT 1.0\n"   ;
printf INFX "PHASE %9.3f %9.3f\n", $ph0, $ph1   ;
printf INFX "PHASE %9.3f %9.3f\n", $inphase0, $inphase1 ;
print INFX "IFFT 1.0\n"   ;

if ($flag == 1 ) {
print INFX "SEFIX1 t2 \n";	
}
if ($watersup==0 && $HN != 1) 
{
print INFX "SSTDC 30 10 0.00\n"   ;
}
if ($HN==1) 
{
print INFX "SSTDC 8 20 0.00\n"   ;
}

print INFX "BC 12.5\n"   ;
print INFX "GM 20.00 20.00\n"   ;
printf INFX "ZEROFILL\n";

if ($numflag==3)
	{
printf INFX "ZEROFILL\n";		# zerofill twice if the number points is not a fourier number and is near the next fourier number
	};
print INFX "FFT 1.0\n"   ;
print INFX "REALPART\n"   ;
if ($HN==1)
{
printf INFX "Shrink %i\n", $shnum   ;
}
print INFX "COM \'Saving f3 processed data as f3_proc.sec\'\n"   ;
print INFX "SAVE f3_proc.sec\n"   ;
print INFX "SEEPAR\n"   ;
print INFX "EOF\n"   ;
print INFX "\n"   ;

printf INFX "export MP_SET_NUMTHREADS=%i\n", $numprocs   ;

printf INFX "echo \'Starting t1 fourier transformation of 3D data set for LP of t2\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
printf INFX "DIM T1\n"   ;
#printf INFX "SINEBELL SHIFT 70.0\n"   ;
printf INFX "ZEROFILL %i\n", $ni_3_ft   ;
printf INFX "FFT 1.0\n"   ;
printf INFX "PHASE 0.0 0.0\n"   ;
#printf INFX "REVERSE\n"   ;
#printf INFX "REALPART\n"   ;
printf INFX "SEEPAR\n"   ;
printf INFX "SAVE temp.sec\n"   ;
printf INFX "EOF\n"   ;
printf INFX "section -c %i %i %i\n", $ni_2_ft*4,  $ni_3_ft*2, $shnum  ;

printf INFX "echo \'Starting t2 fourier transformation/LP of 3D data set\'\n"   ;
print INFX  "rnmrtk << EOF\n"   ;
printf INFX "LOAD temp.sec\n"   ;
printf INFX "DIM T2\n"   ;
printf INFX "ZEROFILL %i\n", $ni_2*2   ;
printf INFX "SHELL \'flip t2 %i %i %i REFLECT\'\n",  $ni_2/4, $ni_2, $ni_2  ;
printf INFX "SINEBELL SHIFT 70.0\n"   ;
printf INFX "ZEROFILL %i\n", $ni_2_ft*2   ;
printf INFX "FFT 0.50\n"   ;
printf INFX "PHASE 0.0 0.0\n"   ;
printf INFX "REALPART\n"   ;
printf INFX "SEEPAR\n"   ;
printf INFX "SAVE temp.sec\n"   ;
printf INFX "EOF\n"   ;

printf INFX "echo \'Starting t1 fourier transformation of 3D data set\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
printf INFX "DIM T1\n"   ;
printf INFX "IFFT 1.0\n"   ;
printf INFX "SHRINK %i\n"   , $ni_3 ;
printf INFX "ZEROFILL %i\n", $ni_3*2   ;
printf INFX "SHELL \'flip t1 %i %i %i REFLECT\'\n",  $ni_3/4, $ni_3, $ni_3  ;
printf INFX "SINEBELL SHIFT 70.0\n"   ;
printf INFX "ZEROFILL %i\n", $ni_3_ft*2   ;
printf INFX "FFT 0.50\n"   ;
printf INFX "PHASE 0.0 0.0\n"   ;
printf INFX "REVERSE\n"   ;
printf INFX "REALPART\n"   ;
printf INFX "SEEPAR\n"   ;
printf INFX "SAVE temp.sec\n"   ;
printf INFX "EOF\n"   ;


printf INFX "section -c %i %i %i\n", $ni_2_ft*2,  $ni_3_ft*2, $shnum;
print INFX "rnmrtk LOAD temp.sec f1 f2 f3\n"   ;
print INFX "\n"   ;
printf INFX "echo \'Saving final data in NMRPipe format as %s.ft3\'\n", $pp   ;
print INFX "echo \'If the file exists it will be overwritten!\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
printf INFX "PUTNMRPIPE %s_f3f2.ft3 f3 f1\n", $pp   ;
printf INFX "PUTXEASY %s. other\n", $pp   ;
printf INFX "load temp.sec\n"   ;
printf INFX "dim 2 xsect sum\n"   ;
printf INFX "putnmrpipe f2_proj.ft2\n"   ;
printf INFX "load temp.sec\n"   ;
printf INFX "dim 1 xsect sum\n"   ;
printf INFX "putnmrpipe f1_proj.ft2\n"   ;
print INFX "EOF\n"   ;
print INFX "\n"   ;
print INFX "echo \'Removing shared memory section\'\n"   ;
print INFX "section -d\n"   ;
print INFX "\n"   ;
print INFX "echo \'Remove comments to clean up intermediate files.\'\n"   ;
print INFX "rm time_3d.sec time_3d.par f3_proc.sec f3_proc.par\n"   ;
print INFX "\n"   ;
}

#------------------------------------------------------------------------------------------
#******************************** LINEAR PROCESSING OF 2D DATA  ************************
sub printproc_lin2d
{
$file2 = "proc_2d\_hr$HR.com";printf INFX "SEEPAR\n"   ;

open(INFX, ">$file2") || die "Can't open output file";

print INFX "\#! /bin/sh\n"   ;
print INFX "\n"   ;
#print INFX "echo \"Creating a shared memory section of \$mem_size Mbytes\"\n"   ;
printf INFX "section -c %i %i\n", $ni_h*2,  $ni_2*4+1  ;
print INFX "\n"   ;
print INFX "echo \'Creating a parameter file for Bruker format and importing data\'\n"   ;
print INFX "if [ -e ser.par ]; then rm ser.par; fi\n"   ;
print INFX "if [ -e ser.dat ]; then mv ser.dat ser.dat.orig; fi\n"   ;
print INFX "if [ -e ser ]; then cp ser ser.dat; else echo \'File ser does not exist! Exiting!\'; exit 1; fi\n"   ;
printf INFX "echo \'Format     %s     int-32\' >> ser.par\n", $bo   ;
print INFX "echo \'DOM     t1     t2    \' >> ser.par\n"   ;
printf INFX "echo \"N     %i C    %i C \" >> ser.par\n", $ni_2, $ni_h  ;
printf INFX "echo \'SW    %9.3f %9.3f \' >> ser.par\n", $sw_2, $sw_h   ;
printf INFX "echo \'SF     %9.3f %9.3f \' >> ser.par\n" , $sw_2/$swp_2, $sw_h/$swp_h    ;
printf INFX "echo \'PPM     %9.3f %9.3f\' >> ser.par\n", $o1_2, $o1_h  ;
print INFX "echo \'QUAD      STATES-TPPI     STATES\' >> ser.par\n"   ;
printf INFX "echo \"LAYOUT T1:%i T2:%i \" >> ser.par\n", $ni_2*2, $ni_h*2   ; 
# $numflag is 1 when ni_h is a fourier number, numflag is 0 when it isn't
$numft=$fnumft=$cnumft=$numflag=$nzftnum=0;
&findftnum($ni_2, $numft, $fnumft, $cnumft, $numflag, $nzftnum);
$ni_2_ft=$nzftnum*2;
$numft=$fnumft=$cnumft=$numflag=$nzftnum=0;

if ($ni_2_ft > 512 && $ni_2_ft < 512)
{
	$ni_2_ft=512
}

if ($HR == 2)
{
	$ni_2_ft = $ni_2_ft*2;
}
if ($HR == 3)
{
	$ni_2_ft = $ni_2_ft*4;
}
if ($HR == 4)
{
	$ni_2_ft = 512;
}
#VC IS CARBON, VP IS NITROGEN
#printf "%i \n", $shnum;
&findftnum($ni_h, $numft, $fnumft, $cnumft, $numflag, $nzftnum);
$shnum=$nzftnum;
if ($HN!=1)
{
$shnum=$nzftnum*2;
}
#printf "%i %i\n", $shnum, $nzftnum;

#	maximum value allowed is 512 512 1024 (technically the value is 2^29-128
if ($ni_2_ft*$ni_3_ft*$shnum > 512*512*2047)	
	{
	printf "The maximum memory size which can be handeled by RNMRTK has been exceeded! \n";
	printf "The resulting script must be modified prior to use, or a smaller data size must be used! \n";
	
#	return;	
	}

printf INFX "section -c %i %i\n", $ni_2_ft*4,  $ni_h*2  ;
print INFX "rnmrtk LOAD ser.dat\n"   ;
print INFX "rnmrtk SEEPAR\n"   ;
print INFX "rm ser.dat\n"   ;
print INFX "\n"   ;
print INFX "\n"   ;



print INFX "echo \'Saving time domain data and setting parameters\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "COM \'Taking the complex conjugate of the acquisition dimension to reverse spectra\'\n"   ;
print INFX "DIM t2\n"   ;
print INFX "CONJ\n"   ;
	if($pp =~ 'sfhmqcf3gpph' || $pp =~ 'hbcbcgcchargp_ts21.be')
	{
print INFX "DIM t1\n"   ;		
print INFX "QUADFIX R I -R -I\n"   ;
print INFX "CONJ\n"   ;

	}
print INFX "COM \'Saving time domain data as time_3d.sec\'\n"   ;
print INFX "SEEPAR\n"   ;
print INFX "EOF\n"   ;
print INFX "echo \'Starting t2 fourier transformation of 2D data set\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
print INFX "DIM t2\n";
if ($flag == 1) {
print INFX "SEFIX1 t1 \n";	
}
if ($HN!=5) 
{
print INFX "SSTDC 8 20 0.00\n"   ;
}
print INFX "BC 12.5\n"   ;
print INFX "GM 20.00 20.00\n"   ;
printf INFX "ZEROFILL\n";

if ($numflag==3)
	{
printf INFX "ZEROFILL\n";		# zerofill twice if the number points is not a fourier number and is near the next fourier number
	};
print INFX "FFT 0.50\n"   ;
printf INFX "PHASE %9.3f %9.3f\n", $ph0, $ph1   ;
printf INFX "PHASE %9.3f %9.3f\n", $inphase0, $inphase1 ;
print INFX "REALPART\n"   ;
if ($HN==1)
{
printf INFX "Shrink %i\n", $shnum   ;
}
print INFX "COM \'Saving f2 processed data as f2_proc.sec\'\n"   ;
print INFX "SAVE f2_proc.sec\n"   ;
print INFX "SEEPAR\n"   ;
print INFX "EOF\n"   ;
print INFX "\n"   ;

printf INFX "export MP_SET_NUMTHREADS=%i\n", $numprocs   ;

printf INFX "section -c %i %i \n", $ni_2_ft*4, $shnum  ;

printf INFX "echo \'Starting t2 fourier transformation/LP of 3D data set\'\n"   ;
print INFX  "rnmrtk << EOF\n"   ;
printf INFX "LOAD f2_proc.sec\n"   ;
printf INFX "DIM T1\n"   ;
printf INFX "ZEROFILL %i\n", $ni_2*2   ;
printf INFX "SHELL \'flip t1 %i %i %i REFLECT\'\n",  $ni_2/8, $ni_2, $ni_2  ;
printf INFX "SINEBELL SHIFT 70.0\n"   ;
printf INFX "ZEROFILL %i\n", $ni_2_ft*2   ;
printf INFX "FFT 0.50\n"   ;
	if($pp =~ 'hbcbcgcchargp_ts21.be')
	{
		print INFX "DIM t1\n"   ;	
		printf INFX "PHASE 90.0 0.0\n"   ;
	}else{	
print INFX "DIM t1\n"   ;	
printf INFX "PHASE 0.0 0.0\n"   ;
	}
printf INFX "REALPART\n"   ;
printf INFX "SEEPAR\n"   ;
printf INFX "SAVE temp.sec\n"   ;
printf INFX "EOF\n"   ;


print INFX "rnmrtk LOAD temp.sec f1 f2\n"   ;
print INFX "\n"   ;
printf INFX "echo \'Saving final data in NMRPipe format as %s.ft3\'\n", $pp   ;
print INFX "echo \'If the file exists it will be overwritten!\'\n"   ;
print INFX "rnmrtk << EOF\n"   ;
printf INFX "PUTNMRPIPE %s.ft2\n", $pp   ;
printf INFX "PUTXEASY %s. hsqc\n", $pp   ;
printf INFX "EOF\n"   ;

print INFX "echo \'Removing shared memory section\'\n"   ;
print INFX "section -d\n"   ;
print INFX "\n"   ;
print INFX "echo \'Remove comments to clean up intermediate files.\'\n"   ;
print INFX "rm f2_proc.sec f2_proc.par\n"   ;
print INFX "\n"   ;
}

#------------------------------------------------------------------------------------------

#********************** CALCULATE SAMPLING SCHEDULE FROM LISTS ***************************************
#****************3d********************************************
sub getsched3d
{

$file = "vclist";	# THIRD INDIRECT DIMENSION -PROTON
$file2 = "vplist";	# SECOND INDIRECT DIMENSION -CARBON
$file3 = "valist";  # FIRST INDIRECT DIMENSION - CARBON
$file4 = "tlkt.scd";
open(INFO, $file)   || die "Can't open input file";		# Open the file
open(INFO2, $file2) || die "Can't open input file";		# Open the file
open(INFO3, $file3) || die "Can't open input file";		# Open the file

@input = <INFO>;		# Read it into an array
@input2 = <INFO2>;
@input3 = <INFO3>;

close(INFO);			# Close the file
close(INFO2);
close(INFO3);


open(INFO4, ">$file4") || die "Can't open output file";
$maxvc=0;
$maxvp=0;
$maxva=0;
$i=0;
foreach $line (@input)
	{
		printf INFO4 "%-3i %-3i %-3i\n", $input3[$i]+1, $input2[$i]+1, $line+1;
		$i=$i+1;
		if ($maxvc < $line+1 ){
		$maxvc=$line+1;
		}
		if ($maxvp < $input2[$i]+1 ){
		$maxvp=$input2[$i]+1;
		}
		if ($maxva < $input3[$i]+1 ){
		$maxva=$input3[$i]+1;
		}	
	}

close(INFO4);
$nlin_3d=$i

}



#****************2d********************************************
sub getsched2d3
{

$file = "nuslist";	# SECOND INDIRECT DIMENSION -CARBON
$file3 = "tlkt.scd";
open(INFO, $file) || die "Can't open input file";		# Open the file
@input = <INFO>;		# Read it into an array
close(INFO);			# Close the file

open(INFO3, ">$file3") || die "Can't open output file";
$maxvc=0;
$maxvp=0;
$i=0;
foreach $line (@input)
	{
				@fieldsx = split (' ', $line);
				$dim1=$fieldsx[0];
				$dim2=$fieldsx[1];
				printf INFO3 "%-3i %-3i\n", $dim1+1, $dim2+1;
		$i=$i+1;
		if ($maxvc < $dim2+1 ){
		$maxvc=$dim2+1;
		}
		if ($maxvp < $dim1+1 ){
		$maxvp=$dim1+1;
		}
	
	}

close(INFO3);
$nlin_2d=$i

}



sub getsched2d
{

$file = "vclist";	# SECOND INDIRECT DIMENSION -CARBON
$file2 = "vplist";	# FIRST INDIRECT DIMENSION -USUALLY NITROGEN
$file3 = "tlkt.scd";
open(INFO, $file) || die "Can't open input file";		# Open the file
open(INFO2, $file2) || die "Can't open input file";		# Open the file
@input = <INFO>;		# Read it into an array
@input2 = <INFO2>;
close(INFO);			# Close the file
close(INFO2);

open(INFO3, ">$file3") || die "Can't open output file";
$maxvc=0;
$maxvp=0;
$i=0;
foreach $line (@input)
	{
		printf INFO3 "%-3i %-3i\n", $input2[$i]+1, $line+1;
		$i=$i+1;
		if ($maxvc < $line+1 ){
		$maxvc=$line+1;
		}
		if ($maxvp < $input2[$i]+1 ){
		$maxvp=$input2[$i]+1;
		}
	
	}

close(INFO3);
$nlin_2d=$i

}
#****************1d********************************************
sub getsched1d
{
	if($pp =~ 'hs15n_wtgs_nl.n')
	{
		$file = "vplist";
	}
	if($pp =~ 'nus_fhsqcf3gpph.t1.be')
	{
		$file = "vclist";
	}

$file = "vclist";
#$file2 = "vplist";
$file3 = "tlkt.scd";
open(INFO, $file) || die "Can't open input file";		# Open the file
#open(INFO2, $file2) || die "Can't open input file";		# Open the file
@input = <INFO>;		# Read it into an array
#@input2 = <INFO2>;
close(INFO);			# Close the file
#close(INFO2);

open(INFO3, ">$file3") || die "Can't open output file";
$maxvd=0;
$i=0;
foreach $line (@input)
	{
		printf INFO3 "%-3i \n", $line+1;
		if ($maxvd < $line+1 ){
		$maxvd=$line+1;
		}
		$i=$i+1;
	}
$nlin_1d=$i;
close(INFO3);

}
#****************1d********************************************

sub getschedcosy
{
    $file = "cosynus";
    $file3 = "tlkt.scd";
    
    open(INFO, $file) || die "Can't open input file";		# Open the file
    @input = <INFO>;		# Read it into an array
    close(INFO);			# Close the file
    
    
    
    open(INFO3, ">$file3") || die "Can't open output file";
    $maxvd=0;
    $i=0;
    foreach $line (@input)
	{
        @fields = split (' ', $line);
        $val= $fields[0];
		printf INFO3 "%.0f \n", $val/$increment;
		$i=$i+1;
	}
    $nlin_1d=$i;
    close(INFO3);
    
}

#******************START COUNTING FOURIER NUMBERS ************************
sub findftnum($ni_h, $numft, $fnumft, $cnumft, $numflag, $nzftnum)
{
# subroutine needs arguments but if you want to play with an input variable to be interchangable use my as below
	    my ($ni_h) = @_;
$numflag=0;
	for ($numft=0; $numft < 15; $numft++)
		{
			
			if ($ni_h == 2**$numft)
			{
				$numflag=1;
				last;	#	exits loop
			}
		

			
			if (2**$numft > $ni_h)
			{
				$cnumft=2**$numft; #ceiling of numft
				last;
			}

			if (2**$numft < $ni_h)
			{
				$fnumft=2**$numft;	#floor of numft
			}
		
		}
# $numflag is 2 when ni_h is nearer the previous fourer number than the next, when the opposite is true $numflag is 3
# so when numflag is 3 zerofill twice, and when it is 2 zerofill once

	if ($numflag != 1)
		{
			if($ni_h-$fnumft < 	$cnumft-$ni_h)
			{
				$numflag=2;	
			}else{
				$numflag=3;				
			
			}
		}

		if ($numflag==1)
		{
		$nzftnum=2**$numft;	
		}
		elsif ($numflag==2)
		{
		$nzftnum=$fnumft;	
		}
		elsif ($numflag==3)
		{
		$nzftnum=$cnumft;	
		}
#		return $nzftnum;
}
#******************END COUNTING FOURIER NUMBERS ************************

