;nus_hccconhgpwg4d.t1.be
;avance-version (08/11/20)
;HCCCONH
;4D sequence with
;   inverse correlation for triple resonance using 
;      dipsi2 and inept transfer steps 
;
;      F1(H,t1) -> F2(Caliph.,t2 -> Ca) -> F2(C=O) -> F3(N,t3) -> F1(H,t4)
;
;on/off resonance Ca and C=O pulses using shaped pulse
;phase sensitive (t1)
;phase sensitive (t2)
;phase sensitive (t3)
;using constant time in t3
;water suppression using watergate sequence
;(use parameterset HCCCONHGPWG3D3)
;
;G.T. Montelione, B.A. Lyons, S.D. Emerson & M. Tashiro, 
;   J. Am. Chem. Soc. 114, 10974-75 (1992)
;S. Grzesiek, J. Anglister & A. Bax, J. Magn. Reson. 101 B, 114-9 (1993)
;B.A. Lyons & G.T. Montelione, J. Magn. Reson. 101 B, 206-9 (1993)
;T.M. Logan, E.T. Olejniczak, R.X. Xu & S.W. Fesik, 
;   J. Biomol. NMR 3, 225-31 (1993)
;R.T. Clowes, W. Boucher, C.H. Hardman, P.J. Domaille & E.D. Laue, 
;   J. Biomol. NMR 3, 349-354 (1993)
;T. Carlomagno, M. Maurer, M. Sattler, M.G. Schwendinger, S.J. Glaser
;   & C. Griesinger, J. Biomol. NMR 8, 161-170 (1996)
;
;$CLASS=HighRes
;$DIM=4D
;$TYPE=
;$SUBTYPE=
;$COMMENT=


prosol relations=<triple>


#include<Avance.incl>
#include<Grad.incl>
#include<Delay.incl>


define list<loopcounter> t1list=<$VCLIST>
define list<loopcounter> t2list=<$VPLIST>
define list<loopcounter> t3list=<$VALIST>


"p2=p1*2"
"p22=p21*2"
"d11=30m"
"d12=20u"

"d3=1.1m"
"d4=1.7m"
"d21=5.5m"
"d22=4.4m"
"d23=12.4m"
"d26=2.3m"
"d28=4.5m"


"d32=3u"
"d51=3u"
"d53=3u"

"d31=d4"
"d33=d23/2-p14/2-p26-d21-4u"
"d41=d4+p14+d51"
"d43=d23/2+p14/2+d53"

"in31=inf1/2"
"in32=inf2/2"
"in33=inf3/4"

"FACTOR1=d41*10000000*2/td1"
"in41=FACTOR1/10000000"

"in51=in31-in41"

"FACTOR2=d43*10000000*2/td3"
"in43=FACTOR2/10000000"

"in53=in33-in43"


"l1=(d15/(p9*115.112))+0.5"


"DELTA1=d3+p2+d32*2+larger(p14,p22)-p14-4u"
"DELTA2=d23+4u-d22"
"DELTA3=d26-p16-d16-p11-12u"
"DELTA4=p26+d21+4u"

"TAU1=d4+p14+d51"
"TAU2=d23/2-p14/2-p26-d21-4u"
"TAU3=d23/2+p14/2+d53"


"spoff2=0"
"spoff3=0"
"spoff5=bf2*((cnst21-cnst23)/1000000)"
"spoff7=bf2*((cnst22-cnst21)/1000000)"
"spoff8=0"
"spoff9=bf2*((cnst22-cnst23)/1000000)"


"COUNTER=l3*l13*l23/8"


1 ze

  "if ( in41 > in31 ) { in41 = in31; in51 = 0; }"
  "if ( in43 > in33 ) { in43 = in33; in53 = 0; }"

  d11 pl16:f3

  20u
  "cnst28=(t1list%2)*180"
  20u
  "cnst29=(t2list%2)*180"
  20u
  "cnst30=(t3list%2)*180"
  20u
  "cnst31=cnst28+cnst29+cnst30"

  20u
  "cnst32=(t1list%4)*90"
  20u
  "cnst33=cnst28-cnst32"

  3m ip3+cnst33
  3m ip4+cnst29
  3m ip6+cnst30
  3m ip31+cnst31

2 d11 do:f3
  3m
3 6m
4 6m
5 30.12m
6 d12 pl9:f1

  d11 fq=cnst23(bf ppm):f2
  d1 cw:f1
  4u do:f1
  d12 pl1:f1 pl3:f3
  50u UNBLKGRAD

  20u
  "d31=d4+in31*t1list"
  20u
  "d41=TAU1-in41*t1list"
  20u
  "d51=3u+in51*t1list"
  20u
  "d32=3u+in32*t2list"
  20u
  "d33=TAU2+in33*t3list"
  20u
  "d43=TAU3-in43*t3list"
  20u
  "d53=3u+in53*t3list"

  (p1 ph3):f1
  d31
  (p14:sp3 ph1):f2
  d51
  (p2 ph1):f1
  d41
  (p1 ph2):f1

  4u
  p16:gp1
  d16

  (p13:sp2 ph4):f2
  d32
  (center (p14:sp5 ph1):f2 (p22 ph1):f3 )
  d3
  (p2 ph1):f1 
  d32
  (p14:sp3 ph1):f2
  DELTA1
  (p14:sp5 ph1):f2
  4u
  (p13:sp8 ph2):f2

  4u
  4u pl15:f2

						;begin FLOPSY16
7 (p9*0.511 ph11):f2
  (p9*1.067 ph12):f2
  (p9*1.822 ph13):f2
  (p9*1.767 ph14):f2
  (p9*1.444 ph15):f2
  (p9*1.767 ph14):f2
  (p9*1.822 ph13):f2
  (p9*1.067 ph12):f2
  (p9*0.511 ph11):f2

  (p9*0.511 ph21):f2
  (p9*1.067 ph22):f2
  (p9*1.822 ph23):f2
  (p9*1.767 ph24):f2
  (p9*1.444 ph25):f2
  (p9*1.767 ph24):f2
  (p9*1.822 ph23):f2
  (p9*1.067 ph22):f2
  (p9*0.511 ph21):f2

  (p9*0.511 ph21):f2
  (p9*1.067 ph22):f2
  (p9*1.822 ph23):f2
  (p9*1.767 ph24):f2
  (p9*1.444 ph25):f2
  (p9*1.767 ph24):f2
  (p9*1.822 ph23):f2
  (p9*1.067 ph22):f2
  (p9*0.511 ph21):f2

  (p9*0.511 ph11):f2
  (p9*1.067 ph12):f2
  (p9*1.822 ph13):f2
  (p9*1.767 ph14):f2
  (p9*1.444 ph15):f2
  (p9*1.767 ph14):f2
  (p9*1.822 ph13):f2
  (p9*1.067 ph12):f2
  (p9*0.511 ph11):f2

  (p9*0.511 ph11):f2
  (p9*1.067 ph12):f2
  (p9*1.822 ph13):f2
  (p9*1.767 ph14):f2
  (p9*1.444 ph15):f2
  (p9*1.767 ph14):f2
  (p9*1.822 ph13):f2
  (p9*1.067 ph12):f2
  (p9*0.511 ph11):f2

  (p9*0.511 ph11):f2
  (p9*1.067 ph12):f2
  (p9*1.822 ph13):f2
  (p9*1.767 ph14):f2
  (p9*1.444 ph15):f2
  (p9*1.767 ph14):f2
  (p9*1.822 ph13):f2
  (p9*1.067 ph12):f2
  (p9*0.511 ph11):f2

  (p9*0.511 ph21):f2
  (p9*1.067 ph22):f2
  (p9*1.822 ph23):f2
  (p9*1.767 ph24):f2
  (p9*1.444 ph25):f2
  (p9*1.767 ph24):f2
  (p9*1.822 ph23):f2
  (p9*1.067 ph22):f2
  (p9*0.511 ph21):f2

  (p9*0.511 ph21):f2
  (p9*1.067 ph22):f2
  (p9*1.822 ph23):f2
  (p9*1.767 ph24):f2
  (p9*1.444 ph25):f2
  (p9*1.767 ph24):f2
  (p9*1.822 ph23):f2
  (p9*1.067 ph22):f2
  (p9*0.511 ph21):f2

  (p9*0.511 ph21):f2
  (p9*1.067 ph22):f2
  (p9*1.822 ph23):f2
  (p9*1.767 ph24):f2
  (p9*1.444 ph25):f2
  (p9*1.767 ph24):f2
  (p9*1.822 ph23):f2
  (p9*1.067 ph22):f2
  (p9*0.511 ph21):f2

  (p9*0.511 ph11):f2
  (p9*1.067 ph12):f2
  (p9*1.822 ph13):f2
  (p9*1.767 ph14):f2
  (p9*1.444 ph15):f2
  (p9*1.767 ph14):f2
  (p9*1.822 ph13):f2
  (p9*1.067 ph12):f2
  (p9*0.511 ph11):f2

  (p9*0.511 ph11):f2
  (p9*1.067 ph12):f2
  (p9*1.822 ph13):f2
  (p9*1.767 ph14):f2
  (p9*1.444 ph15):f2
  (p9*1.767 ph14):f2
  (p9*1.822 ph13):f2
  (p9*1.067 ph12):f2
  (p9*0.511 ph11):f2

  (p9*0.511 ph21):f2
  (p9*1.067 ph22):f2
  (p9*1.822 ph23):f2
  (p9*1.767 ph24):f2
  (p9*1.444 ph25):f2
  (p9*1.767 ph24):f2
  (p9*1.822 ph23):f2
  (p9*1.067 ph22):f2
  (p9*0.511 ph21):f2

  (p9*0.511 ph21):f2
  (p9*1.067 ph22):f2
  (p9*1.822 ph23):f2
  (p9*1.767 ph24):f2
  (p9*1.444 ph25):f2
  (p9*1.767 ph24):f2
  (p9*1.822 ph23):f2
  (p9*1.067 ph22):f2
  (p9*0.511 ph21):f2

  (p9*0.511 ph21):f2
  (p9*1.067 ph22):f2
  (p9*1.822 ph23):f2
  (p9*1.767 ph24):f2
  (p9*1.444 ph25):f2
  (p9*1.767 ph24):f2
  (p9*1.822 ph23):f2
  (p9*1.067 ph22):f2
  (p9*0.511 ph21):f2

  (p9*0.511 ph11):f2
  (p9*1.067 ph12):f2
  (p9*1.822 ph13):f2
  (p9*1.767 ph14):f2
  (p9*1.444 ph15):f2
  (p9*1.767 ph14):f2
  (p9*1.822 ph13):f2
  (p9*1.067 ph12):f2
  (p9*0.511 ph11):f2

  (p9*0.511 ph11):f2
  (p9*1.067 ph12):f2
  (p9*1.822 ph13):f2
  (p9*1.767 ph14):f2
  (p9*1.444 ph15):f2
  (p9*1.767 ph14):f2
  (p9*1.822 ph13):f2
  (p9*1.067 ph12):f2
  (p9*0.511 ph11):f2
  lo to 7 times l1
						;end FLOPSY16

  d12 pl19:f1
  (p26 ph1):f1
  d12 cpds1:f1 ph2

  (p13:sp2 ph2):f2
  4u
  (p14:sp5 ph1):f2
  d28 
  (p24:sp9 ph1):f2
  4u
  (p14:sp5 ph1):f2
  d28
  (p13:sp8 ph1):f2

  4u
  d12 fq=cnst21(bf ppm):f2

  (p13:sp2 ph5):f2
  d22
  (p14:sp7 ph1):f2
  DELTA2
  (center (p14:sp3 ph1):f2 (p22 ph8):f3 )
  d23
  (p14:sp7 ph1):f2
  4u
  (p13:sp8 ph1):f2

  4u
  4u do:f1
  (p26 ph10):f1
  4u
  p16:gp2
  d16
  (p26 ph2):f1
  4u cpds1:f1 ph1

  (p21 ph6):f3
  d43
  (p14:sp7 ph1):f2
  d43
  (p22 ph1):f3
  d53
  (p14:sp7 ph1):f2
  d53
  (p14:sp3 ph1):f2
  DELTA4
  d33
  (p14:sp7 ph1):f2
  d33
  4u do:f1
  (p26 ph9):f1
  d21
  (p21 ph1):f3

  p16:gp3
  d16 pl0:f1
  (p11:sp1 ph7):f1
  4u
  4u pl1:f1

  (p1 ph1) 
  4u
  p16:gp4
  d16
  DELTA3 pl0:f1
  (p11:sp1 ph7):f1
  4u
  4u pl1:f1
  (center (p2 ph1) (p22 ph1):f3 )
  4u pl0:f1
  (p11:sp1 ph7):f1
  4u
  DELTA3
  p16:gp4
  d16 pl16:f3
  4u BLKGRAD
  go=2 ph31 cpd3:f3
;  d11 do:f3 mc #0 to 2 
;     F1PH(rd32 & rp4 & ip3, id31 & dd41 & id51 & dp3)
;     F2PH(rd33 & rd43 & rd53 & rp6 & ip4, id32) 
;     F3PH(dp6, id33 & dd43 & id53)


  d11 do:f3 wr #0 if #0 zd

  3m dp6
  lo to 3 times 2

  3m ip6*2
  3m ip4
  lo to 4 times 2

  3m dp4*2
  3m ip3
  lo to 5 times 2

  3m rp3
  3m rp4
  3m rp6
  3m t1list.inc
  3m t2list.inc
  3m t3list.inc

  20u
  "cnst28=(t1list%2)*180"
  20u
  "cnst29=(t2list%2)*180"
  20u
  "cnst30=(t3list%2)*180"
  20u
  "cnst31=cnst28+cnst29+cnst30"

  20u
  "cnst32=(t1list%4)*90"
  20u
  "cnst33=cnst28-cnst32"

  3m ip3+cnst33
  3m ip4+cnst29
  3m ip6+cnst30
  3m ip31+cnst31

  lo to 6 times COUNTER



exit


ph1=0
ph2=1
ph3=0 0 0 0 0 0 0 0 2 2 2 2 2 2 2 2
ph4=0 0 2 2
ph5=0 0 0 0 2 2 2 2
ph6=0 2
ph7=2
ph8=0
ph9=3
ph10=2

ph11=(720) 0
ph12=(720) 90
ph13=(720) 135
ph14=(720) 630
ph15=(720) 45

ph21=(720) 360
ph22=(720) 450
ph23=(720) 495
ph24=(720) 270
ph25=(720) 405

ph31=0 2 2 0 2 0 0 2 2 0 0 2 0 2 2 0



;pl0 : 120dB
;pl1 : f1 channel - power level for pulse (default)
;pl3 : f3 channel - power level for pulse (default)
;pl15: f2 channel - power level for TOCSY-spinlock
;pl16: f3 channel - power level for CPD/BB decoupling
;pl19: f1 channel - power level for CPD/BB decoupling
;sp1: f1 channel - shaped pulse  90 degree  (H2O on resonance)
;sp2: f2 channel - shaped pulse  90 degree  (C=O on resonance)
;sp3: f2 channel - shaped pulse 180 degree  (on resonance)
;sp5: f2 channel - shaped pulse 180 degree  (C=O off resonance)
;sp7: f2 channel - shaped pulse 180 degree  (Ca off resonance)
;sp8: f2 channel - shaped pulse  90 degree  (on resonance)
;                  for time reversed pulse
;sp9: f2 channel - shaped pulse 180 degree  (Ca on resonance)
;     sp9 might require higher selectivity than sp3
;p1 : f1 channel -  90 degree high power pulse
;p2 : f1 channel - 180 degree high power pulse
;p9 : f2 channel -  90 degree low power pulse
;p11: f1 channel -  90 degree shaped pulse             [1 msec]
;p13: f2 channel -  90 degree shaped pulse
;p14: f2 channel - 180 degree shaped pulse
;p16: homospoil/gradient pulse                         [1 msec]
;p21: f3 channel -  90 degree high power pulse
;p22: f3 channel - 180 degree high power pulse
;p24: f2 channel - 180 degree shaped pulse (sp9)
;p26: f1 channel -  90 degree pulse at pl19
;d32 : incremented delay (F1 in 3D)                     [3 usec]
;d1 : relaxation delay; 1-5 * T1
;d3 : 1/(6J(CH)                                        [1.1 msec]
;d4:  1/(4J(CH)                                        [1.7 msec]
;d10: incremented delay (F2 in 3D) = d23/2-p14/2
;d11: delay for disk I/O                               [30 msec]
;d12: delay for power switching                        [20 usec]
;d15: TOCSY mixing time                                [12 msec]
;d16: delay for homospoil/gradient recovery
;d28: 1/(2J(CaCO))                                     [4.5 msec]
;d22: 1/(2J'(CaCO)                                     [4.4 msec]
;d23: constant time delay T(N) = 1/(4J'(NCO)           [12.4 msec]
;d21: 1/(2J'(NH))                                      [5.5 msec]
;d26: 1/(4J(NH))                                       [2.3 msec]
;d29: incremented delay (F2 in 3D) = d23/2-p14/2-p26-d21-4u
;d30: decremented delay (F2 in 3D) = d23/2-p14/2
;cnst21: CO chemical shift (offset, in ppm)
;cnst22: Calpha chemical shift (offset, in ppm)
;cnst23: Caliphatic chemical shift (offset, in ppm)
;o2p: Caliphatic chemical shift (cnst23)
;l1: loop for DIPSI2 cycle: ((p6*115.112) * l1) = mixing time
;inf1: 1/SW(Cali) = 2 * DW(Cali)
;inf2: 1/SW(N) = 2 * DW(N)
;in0: 1/(2 * SW(Cali)) =  DW(Cali)
;nd32: 2
;in10: 1/(2 * SW(N)) = DW(N)
;nd10: 4
;in29: = in10
;in30: = in10
;NS: 16 * n
;DS: >= 16
;td1: number of experiments in F1
;td2: number of experiments in F2       td2 max = 2 * d30 / in30
;FnMODE: States-TPPI (or TPPI) in F1
;FnMODE: States-TPPI (or TPPI) in F2
;cpds1: decoupling according to sequence defined by cpdprg1
;cpd3: decoupling according to sequence defined by cpdprg3
;pcpd1: f1 channel - 90 degree pulse for decoupling sequence
;pcpd3: f3 channel - 90 degree pulse for decoupling sequence


;use gradient ratio:    gp 1 : gp 2 : gp 3 : gp 4
;                         50 :   40 :   60 :   30

;for z-only gradients:
;gpz1: 50%
;gpz2: 40%
;gpz3: 60%
;gpz4: 30%

;use gradient files:   
;gpnam1: SINE.100
;gpnam2: SINE.100
;gpnam3: SINE.100
;gpnam4: SINE.100



;$Id: $
