/* M. Mobli - 2008 Brisbane (CAI/UQ)*/
// most recent update 20151025 - edited bin handling of jittered sampling



#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#define MAX 128*128*128
#define compGT(a,b) (a < b)

void msort(float[],float[],int[],int[],int[],int,int);
void msorta(int[],float[],float[],int[],int[],int[],int,int);

int main( int argc, char** argv)
{
FILE *fl;
FILE *fl2;
FILE *fl3;
FILE *fl4;
int *numtabi = ( int * ) malloc( MAX*sizeof( int ) );
int *numtabj = ( int * ) malloc( MAX*sizeof( int ) );
int *numtabk = ( int * ) malloc( MAX*sizeof( int ) );
int *tempvec = ( int * ) malloc( MAX*sizeof( int ) );
int *binid = ( int * ) malloc( MAX*sizeof( int ) );
int *binlim = ( int * ) malloc( MAX*sizeof( int ) );
float *key  = ( float * ) malloc( MAX*sizeof( float ) );
float *keyp = ( float * ) malloc( MAX*sizeof( float ) );
float *rand_t = ( float * ) malloc( MAX*sizeof( float ) );
char sched[100], sched1[100], sched2[100], sched3[100], parfile[1000];
char dum, buffer[1000], fline[1000], dum2[100];
int i, j, k, N, M, O, P, DUM_N,seed_s, x, tempi, DUM_N1, ptr,skip,binfloor,irand;
int smod1,smod2,smod3, jit,sort, strides[4], pr[4],ne[4], bptr,sum[4],ncandtot,binptr, patch, veccount,tptr;
int cand[10000][4],posa[4],beta[4],neigh[10000][7],totcand, neighb, addp[10000],cls[10000];
float LW1, LW2, LW3, pi, sw1, sw2, sw3, frac, bestp, cent[4], bcent[10000][4],dist1,dist2,totprob;
int ndim, MAXSAMP, output, force,ncand[4],cos1,cos2,cos3,posa1,posa2,posa3, binceil,l;
float pmod1, pmod2, pmod3,alpha;
float av_num1, av_num2, av_num3, thresh, j1, j2, j3, fdum, mod1, mod2, mod3;
float js1, js2, js3,bine, scale;
double tempf, tempf1, tempf2, tempf3, tempfx, sumtemp, bin, nearest, near, t_rand, residual, cpub,currp, pbin, pd[10000];

    
    if (numtabi == 0 || numtabj ==0 || numtabk == 0 || keyp == 0 || key == 0 || rand_t == 0 || binlim == 0 || binid == 0 )
	{
		printf("ERROR: Could not allocated memory\n");
				
		return 1;
	}

	MAXSAMP=MAX;
    jit=0;
    cos1=cos2=cos3=0;
    posa[1]=posa[2]=posa[3]=-1;
    beta[1]=beta[2]=beta[3]=0;
    for (k=0 ;k< 10000 ;k++)
    {
        addp[k]=cls[k]=0;
        pd[k]=0.0;
      for (j=0 ; j< 7 ; j++)
	{
	  neigh[k][j]=0;
	}  
    }
    bestp=0.0;
    dist1=dist2=0;
    t_rand=residual=cpub=0.0;
	seed_s=0;
    sort=0;
	force=0;
	i=0;
	j=0;
	k=0;
	M=0;
	N=1;
	O=1;
	P=1;
	ptr=0;
	DUM_N=0;
	DUM_N1=0;
	ndim=0;
	LW1=0.0;
	sw1=0.0;
	j1=0.0;
	LW2=0.0;
	sw2=0.0;
	j2=0.0;
	LW3=0.0;
	sw3=0.0;
	j3=0.0;
	tempf1=0.0;
	tempf2=0.0;
	tempf3=0.0;
    output=0;
	thresh=0.0;
	mod1=mod2=mod3=1.0;
    js1=js2=js3=0.0;
    smod1=smod2=smod3=0;
	bin=near=nearest=0.0;
// 	FROM FILE

	if (argc != 3)
	{
	printf("Incorrect number of paramters. Program aborted!\n Usage: sched3d input.txt ouput.txt \n");
	return 1;
	}
	sprintf(parfile, argv[1]); 
	sprintf(sched, argv[2]);	
	fl = fopen(parfile ,"r");
	if( fl ) {
	fclose(fl);
	} else {
	printf ("Input file %s not found.\n", parfile); 
		return 1;
	}
	fl  = fopen (parfile, "r"); 

    while(fgets(buffer, 1000, fl) !=NULL)
    {
        sscanf(buffer, "%s" , &fline);
//	RANDOM SEED		
            if (strcmp(fline, "RAND_SEED") == 0 || strcmp(fline, "rand_seed") == 0)
            	{
            	sscanf(buffer, "%*s %i ", &seed_s); // seed					
                }
//       NDIM
            if (strcmp(fline, "NDIM") == 0 || strcmp(fline, "ndim") == 0)
            	{
            	sscanf(buffer, "%*s %i ", &ndim); //  ndim

                }
//	Number of points in subset
            if (strcmp(fline, "NPTS_SUB") == 0 || strcmp(fline, "npts_sub") == 0)
            	{
            	sscanf(buffer, "%*s %i ", &M); // subset					
                    if (M <= 0)
                    {
                        printf("Invalid number of points specified in subset! Abort.\n");
                        return 1;
                    }
                }
//	npts in active dimensions		
            if (strcmp(fline, "NPTS") == 0 || strcmp(fline, "npts") == 0)
            	{
            	sscanf(buffer, "%*s %i %i %i ", &N, &O, &P); // read data from 2d peak list
                    if (N <= 0)
                    {
                        printf("Invalid number of points specified in dimension 1! Abort.\n");
                        return 1;
                    }
                    if (O <= 0)
                    {
                        O=1;
                    }
                    if (P <= 0)
                    {
                        P=1;
                    }
                }
//	SWEEP WIDTH		
            if (strcmp(fline, "SW") == 0 || strcmp(fline, "sw") == 0)
            	{
            	sscanf(buffer, "%*s %f %f %f ", &sw1, &sw2, &sw3 ); // 					
                }
//	LINE WIDTH
            if (strcmp(fline, "LW") == 0 || strcmp(fline, "lw") == 0)
            	{
            	sscanf(buffer, "%*s %f %f %f ", &LW1, &LW2, &LW3 ); // 					
                }
//	Jittered
            if (strcmp(fline, "Jit") == 0 || strcmp(fline, "jit") == 0 || strcmp(fline, "JIT") == 0)
            {
                sscanf(buffer, "%*s %i", &jit );
                if (jit != 3 && jit != 2 && jit != -1)
                {
                    jit=0;
                }
                // jit=2 => probability weighted jittered sampling (within regions) [jitp]
                // jit=3 => non-weighted jittered sampling (within regions) [jitg]
                // jit=-1 => probability weighted region determination (random within each region)
                // the last option is not strictly jittered sampling where the distribution is modulated by sine/cos function
            }
            
            //	Poisson approximation according to SEJS1 when = 0 , values larger than 1 sets the exponent in the sinebell weighting
            if (strcmp(fline, "sine") == 0 || strcmp(fline, "SINE") == 0 || strcmp(fline, "Sine") == 0)
            {
            	sscanf(buffer, "%*s %i %i %i ", &posa[1], &posa[2], &posa[3] );

            // looking for syntax sine 0 -1 0 # the equation a ( sin^[2*beta] (pi/2+xpi/N) )   +  (1-alpha)
            // when sine is 0, alpha=0.6, beta=8; this is a close approximation to poisson ditribution [SEJS1]
            // when sine is >=1 then alpha is 0.7, beta is the user input. i.e. Sine 4, would result in alpha=0.7 beta=8
            // SEJS2 = beta=8, jit=4
            // SEJS1 = beta=6, jit=0 or jit=3 (note when jit=0, then alpha is 0.6 and when jit=3 then alpha is 0.7)
            // note posa initialised to -1
            }
//	SINE MODULATION (COSY)
            if (strcmp(fline, "COSY") == 0 || strcmp(fline, "cosy") == 0|| strcmp(fline, "Cosy") == 0)
            {
            	sscanf(buffer, "%*s %f %f %f ", &js1, &js2, &js3 );
                if (js1 != 0.0) smod1=1; //sets default to 6Hz if not defined
                if (js2 != 0.0) smod2=1;
                if (js3 != 0.0) smod3=1;
            }
            if (strcmp(fline, "COSINE") == 0 || strcmp(fline, "cosine") == 0|| strcmp(fline, "Cosine") == 0)
            {
            	sscanf(buffer, "%*s %i %i %i ", &cos1, &cos2, &cos3 ); //
            }
//	J
            if (strcmp(fline, "J") == 0 || strcmp(fline, "j") == 0)
            {
            	sscanf(buffer, "%*s %f %f %f ", &j1, &j2, &j3 ); // read data from 2d peak list					
            }
//	sort FORCE/SORT
            if (strcmp(fline, "SORT") == 0 || strcmp(fline, "sort") == 0|| strcmp(fline, "Sort") == 0) // IF SORT IS 0 THEN DON'T SORT
            {
                    sort=1;
            }
            if (strcmp(fline, "FORCE") == 0 || strcmp(fline, "force") == 0|| strcmp(fline, "Force") == 0)
            {
                    force=1;
            }
		
//	FORMAT		
         if (strcmp(fline, "FORMAT") == 0 || strcmp(fline, "format") == 0)
		 {
             sscanf(buffer, "%*s %i ", &output );
             if (output != 3 && output != 2 && output != 1)
             {
                 output=0;
             }
		 }
	}	// end reading file
    
    
    if (ndim > 3 || ndim <= 0 )
	{
		printf("Program can only handle 1-3 dimensions (and input must be an integer value).\n");
		return 1;
	}
	
	if (ndim == 1)
	{ 
	sw3=0.0;
	sw2=0.0;
	P=1;
	O=1;
		if (sw1 == 0  )
		{
		printf ("ERROR SW IN DIM 1 IS 0! \n");
		return 1;
		}
	}


	if (ndim == 2)
	{ 
	sw3=0.0;
	P=1;
		if (sw2 == 0 || O == 0 )
		{
		printf ("ERROR: SW OR NPTS IN DIM 2 IS 0! \n");
		return 1;	
		}
	}	
	if (ndim == 3)
	{ 
		if (sw2 == 0 || O == 0 || sw3 == 0 || P == 0 )
		{
		printf ("ERROR SW OR NPTS IN DIM 2 OR 3 IS 0! \n");
		return 1;	
		}
	}	

	if (M > N*O*P)
	{
		printf("Subset must be smaller than the total points.\n");
		return 0;
	}	
	if (N*O*P > MAX)	
	{
		printf("Maximum memory allocation exceeded, choose a smaller datasize.\n");
		return 0;
	}


// *************   parameter reading and error checking complete  ************	

	pi=3.141592654;
	srand (seed_s);	

// numtabi goes with N,
// numtabj goes with O,
// numtabk goes with P,
    
	DUM_N=N;

    strides[1]=1;
    strides[2]=strides[3]=0;
	if (ndim > 1)
	{
	DUM_N=N*O;
        strides[2]=N;
        if(ndim > 2)
		{
		DUM_N=N*O*P;
            strides[3]=O;
            
		}
	}
    for (i = 0 ; i < DUM_N ; i++)
    {
        numtabk[i]=numtabj[i]=numtabi[i]=binlim[i]=binid[i]=0;
        rand_t[i]=(double)rand() / (double)RAND_MAX;
    }
	DUM_N1=DUM_N;

	ptr=0;
// ptr runs from 0 to N*O*P	
	sumtemp=0.0;
	pmod1=pmod2=pmod3=1.0;
	for (i=1 ; i<4 ; i++)
	{
	  if (posa[i]==0) // this is to reproduce poisson sampling
	  {
	   scale=0.6;
	   beta[i]=8;
	  }
	  if (posa[i]>=1) // this enables fine tuning of the sine weighting although scale is hardcoded
	  {  
	   scale=0.7;
	   beta[i]=2*posa[i];
	  }
	}
	for (k=0 ; k < P ; k++)
	{
		for (j=0 ; j < O ; j++)
		{
			for(i=0 ; i < N ; i++)
			{
				if (ndim >= 1 && posa[1]>=0)   pmod1=pow((sin(pi*0.5+(float)i*pi/((float)N))),beta[1])*scale+(1.0-scale);
				if (ndim == 2 && posa[2]>=0)
				{
					pmod2=pow((sin(pi*0.5+(float)j*pi/((float)O))),beta[2])*scale+(1.0-scale);
					if (pmod2 > pmod1) 
					{					
						pmod1=1.0;
					}else{
						pmod2=1.0;
					}
				}
				if (ndim == 3 && posa[3]>=0)
				{ 					
					pmod2=pow((sin(pi*0.5+(float)j*pi/((float)O))),beta[2])*scale+(1.0-scale);
					pmod3=pow((sin(pi*0.5+(float)k*pi/((float)P))),beta[3])*scale+(1.0-scale);
					if (pmod3 > pmod1 && pmod3 > pmod2) 
					{					
						pmod1=pmod2=1.0;
					}else{
						pmod3=1.0;
					}
				}
		
		
		
                if (smod1==1) mod1=fabs(sin(pi*js1*((float)i/sw1)));


	        if (cos1==1)
                {
                    tempfx=cos( ((float)i*pi) / (2.0*(float)N) )* fabs(cos(pi*j1*((float)i/sw1)))*mod1*pmod1;
                }else{
                    tempfx=exp(-((float)i/sw1)*pi*LW1)*fabs(cos(pi*j1*((float)i/sw1)))*mod1*pmod1; // mod code is there to add sinemodulation
				}
                if (ndim > 1)
				{
                    if (smod2==1) mod2=fabs(sin(pi*js2*((float)j/sw2)));

                    if (cos2==1)
                    {
                        tempf2=cos( ((float)j*pi) / (2.0*(float)O) ) * fabs(cos(pi*j2*((float)j/sw2)))*mod2*pmod2 ;
                        tempfx=tempfx*tempf2;
                    }else{
                        tempf2=exp(-((float)j/sw2)*pi*LW2)*fabs(cos(pi*j2*((float)j/sw2)))*mod2*pmod2;
                        tempfx=tempfx*tempf2;
                    }
					if (ndim > 2)
					{
                         if (smod3==1) mod3=fabs(sin(pi*js3*((float)k/sw3)));

                        if (cos3==1)
                        {
                            tempf3=cos( ((float)k*pi) / (2.0*(float)P) ) * fabs(cos(pi*j3*((float)k/sw3)))*mod3*pmod3 ;
                            tempfx=tempfx*tempf3;
                        }else{
                            tempf3=exp(-((float)k/sw3)*pi*LW3)*fabs(cos(pi*j3*((float)k/sw3)))*mod3*pmod3;
                            tempfx=tempfx*tempf3;
                        }
					}
				}
				tempf=rand_t[ptr];
                 key[ptr]=0.0;
				if (tempfx != 0.0 && jit!= 3) key[ptr]=powf(tempf,1/tempfx);  // key is a random probability according to distribution tempfx ** r(i) from paper
                if (tempfx != 0.0 && jit== 3) key[ptr]=tempf;  // key is a random probability according to distribution tempfx ** r(i) from paper

                 keyp[ptr]=tempfx;      // keyp and tempfx here is the density at the point ptr, w(i) from paper
                 sumtemp= tempfx+sumtemp;
				numtabi[ptr]=i;
				numtabj[ptr]=j;
				numtabk[ptr]=k;
				ptr=ptr+1;
                
			}
		}
	}
    // ptr goes as x*i+y*j+z*k, so first point is 0,0,0 and ptr is 0+0+0, coordinate 1,0,0 is 1+0+0
    // and first point of second row is 0,1,0 ** strides in dim 1 is 1, strides in dim 2 is N-1, strides in dim 3 is O
    //  0*strides[1]+1*strides[2]+0*strides[3]
    //
   

	frac=0.2;
	//assumes order is P O N, P=FAST, O=SLOW, N=VERY SLOW
	x=0;
 
    if (jit == 0)   // when it is not jittered sort array key until M top values have been found.
    {
        msort(key,keyp,numtabi,numtabj,numtabk,0,DUM_N-1); // SORTS IN DECENDING ORDER BASED ON KEY
        tempf=0.0;
        for (j=0 ; j < M ; j++)
        {
            tempf=tempf+keyp[j]/sumtemp;
        }
       // printf ("TE sens %f , Rel sens %f\n", tempf/(float)M, (tempf/(float)M) / (1.0/((float)DUM_N) ));

    }
    
    
    thresh=0.0;
    if (jit >= 2)   // when it is jittered sort array keyp for all values
    {

        for (i=0 ; i < DUM_N ; i++)
        {
            keyp[i]=keyp[i]/sumtemp;     // at this point i will never be evaluated again, so it can be normalised
            //printf ("%f\n", keyp[i]);

        }
        bin=1.0/(double)M;
        ptr = 0;
        veccount = 0;
        binptr = 1;
        residual=0.0;
        bine=0.0;
        totprob=0;
     while ( binptr <= M )     // ***** start making patches
     {
         bin = (1-totprob)/ ( (double)(M - binptr +1) );

         residual=0.0;

        near = 0.0;
        ptr = -1;
        for (i=0 ; i < DUM_N ; i++)
        {
            if (keyp[i] > near && binid[i] == 0)  // KEY PTR GOES FROM 1 TO 0 WITH DECREASING PROBABILITY
            {
                near = keyp[i];
                ptr = i;            // For random data it will simply evaluate points base don order in ptr
            }
        }
        // printf ("%i %f %f %i\n", binptr,bin,residual,ptr);
        // printf("PTR: %i\n",ptr);

         if (ptr == -1) break;
        // if ptr is -1 at this stage it means that all points belong to a bin so needs to exit / or all points have 0 probability
// 1.

        // NUMBER OF BINS IS M ** Ptr has the highest probability. tempvec[0] starts at ptr
        // tempvec is a temporary vector that defines the points in the current bin
        // binvec is a vector that contains the bin id of each point. ** might not need this if point is generated on the fly.
        // veccount is a counter that keeps track of the number elements in tempvec
        veccount = 1;
        tempvec[veccount] = ptr; //
        currp = keyp[ptr] ;//  // probability of the current bin ** starts with the first point.
        binid[ptr] = binptr; // each index will be assigned a bin
        patch = 0;
         

        while (patch == 0)    // define M bin borders and store these in binlim
        {

            // identify neighbours of tempvec[veccount]
// end 1.
            ncand[1]=ncand[2]=ncand[3]=0;
            // edges of numtabx are : N, O, P respectively
            pr[1]=ne[1]=pr[2]=ne[2]=pr[3]=ne[3]=-1;
// 1 a
            //printf ("Vector count %i  %i %f %i\n", veccount, binptr, currp,tempvec[veccount] );
// input is 
//  number of points to seek neighbours = veccount
//	tempvec contains the pointer of each veccount point 
//	numtbi,j,k index at pointer
//	strides1/2/3 strides for going to the next index point along numtab
//	n,m,o number of points in different dimensions
//	binid = bin id of neighbours

            for (k =1 ; k <= veccount ; k++)
            {
             ptr = tempvec[k]; // make it a pointer for sanity

	     totcand=0;
             if (ndim >= 1) // note: only checks immediate neighbours
             {
               if (numtabi[ptr] > 0 ) // previous point along dim 1 is available (first point is 0)
               {
                   pr[1] = numtabi[ptr]-1; // coordinate of previous point in i
                   tptr=strides[1]*pr[1]+strides[2]*numtabj[ptr]+strides[3]*numtabk[ptr];
                   //** absolute pointer position is :strides[1]*p[1]+strides[2]*numtabj[ptr]+strides[3]*numtabk[ptr]
                   if (binid[tptr] == 0)
                   {

                   ncand[1]++;
                   cand[ncand[1]][1]=tptr;
                   }else{
		    totcand++;
		    neigh[k][totcand]=tptr;
		   }
               }
               if (numtabi[ptr]+1 < N )    // next point along dim 1 is available (last point is N-1)
               {

                   ne[1] = numtabi[ptr]+1; // coordinate of next point in i
                   tptr=strides[1]*ne[1]+strides[2]*numtabj[ptr]+strides[3]*numtabk[ptr];
                   if (binid[tptr] == 0)
                   {

                   ncand[1]++;
                   cand[ncand[1]][1]=tptr;
                   }else{
		    totcand++;
		    neigh[k][totcand]=tptr;
		   }

                }
                
              }
              if (ndim >= 2)
              {
                if (numtabj[ptr] > 0 ) // previous point along dim 2 is available (first point is 0)
                {

                    pr[2] = numtabj[ptr]-1;
                    tptr=strides[1]*numtabi[ptr]+strides[2]*pr[2]+strides[3]*numtabk[ptr];
                    if (binid[tptr] == 0)
                    {
                        ncand[2]++;
                        cand[ncand[2]][2]=tptr;

                    }else{
		    totcand++;
		    neigh[k][totcand]=tptr;
		    }

                }
                if (numtabj[ptr]+1 < O )
                {
                    ne[2] = numtabj[ptr]+1;
                    tptr=strides[1]*numtabi[ptr]+strides[2]*ne[2]+strides[3]*numtabk[ptr];
                    if (binid[tptr] == 0)
                    {
                     ncand[2]++;
                     cand[ncand[2]][2]=tptr;
                    }else{
		    totcand++;
		    neigh[k][totcand]=tptr;
		    }
                }
               
             }
              if (ndim >= 3)
              {
                if (numtabk[ptr] > 0 ) // previous point along dim 3 is available (first point is 0)
                {
                    pr[3] = numtabk[ptr]-1;
                    tptr=strides[1]*numtabi[ptr]+strides[2]*numtabj[ptr]+strides[3]*pr[3];
                    if (binid[tptr] == 0)
                    {
                     ncand[3]++;
                     cand[ncand[3]][3]=tptr;
                    }else{
		    totcand++;
		    neigh[k][totcand]=tptr;
		    }
                }
                if (numtabk[ptr]+1 < P )
                {
                    ne[3] = numtabk[ptr]+1;
                    tptr=strides[1]*numtabi[ptr]+strides[2]*numtabj[ptr]+strides[3]*ne[3];
                    if (binid[tptr] == 0)
                    {
                     ncand[3]++;
                     cand[ncand[3]][3]=tptr;
                    }else{
		    totcand++;
		    neigh[k][totcand]=tptr;
		    }
                }
                
             }

            }


// end 1 a - at this point ncand points have been identified as neighbours to the veccount elements in tempvec
            
            sum[1]=sum[2]=sum[3]=0;
            

            for (i=1 ; i <= veccount ; i++)
            {
                sum[1] = numtabi[tempvec[i]]+sum[1];
                sum[2] = numtabj[tempvec[i]]+sum[2];
                sum[3] = numtabk[tempvec[i]]+sum[3];
            }

            for (j=1 ; j<=ndim ; j++)
            {
                cent[j]=0.0;
                if (veccount>0) cent[j] = (float)sum[j]/(float)veccount;
            }

// 1 b

            ncandtot=0;
            bestp=-1.0;
            bptr=0;
            pbin = 0.0;
            alpha = 1.0*(1.0/(float)DUM_N);
            for (i = 1 ; i <= ndim ; i++)   // this orders the evaluated points based on which dimension they are along
            {
            if (ncand[i] > 0) // neighbours exist for dimension i
               {
                   ncandtot++;  // everything that goes in here will be evaluated.
                   for ( j = 1 ; j <= ncand[i] ; j++)    // evaluate all candidates along dimension i
                   {
                       ptr = cand[j][i] ; // ptr is the index of the point along dimension i

                        if (fabs(keyp[ptr] - bestp) <= alpha && bestp >= 0.0) // b, i  => this can only occur if more than 1 point has been evaluted as bestp is -1 when we start

                        {    // dist is the distance of current point to the centroid

                           dist1 = sqrt( pow( (float)numtabi[bptr]-cent[1],2) + pow( (float)numtabj[bptr]-cent[2],2) + pow( (float)numtabk[bptr]-cent[3],2 ) )/(float)ndim;
                           dist2 = sqrt( pow( (float)numtabi[ptr] -cent[1],2) + pow( (float)numtabj[ptr] -cent[2],2) + pow( (float)numtabk[ptr] -cent[3],2 ) )/(float)ndim;
			   
			   if (dist1 > dist2) // only replace the value if the current point is closer than what previous point of same probability
                                               // expand later to pick point with fewest neighbours
                            {
                                bestp=keyp[ptr];
                                bptr=ptr;
                            }

// dist 1 is distance of previous highest probability point, dist 2 is current, replace only if dist1 is larger than dist 2
// in the general case it is rare that ptrs have the same probability, since this is the most intense computation do this for both previous and current when required, and not for every point evaluated.

                        }
                       
                       else if (keyp[ptr]>bestp) // note the order is important
		       {
                           bestp=keyp[ptr];
                           bptr=ptr;
                       }
                       
                   }
               }
            }
             
           // printf ("%i\n", ncandtot);


            pbin = currp+bestp;
// 1 c

                if ( fabs(fabs(pbin) - fabs(bin)) < fabs(fabs(currp) - fabs(bin)) && ncandtot > 0)
                    // if adding a new point takes closer to the bin edge then include it and start again,
                    // also if bestp = 0 it starts a new patch
                {

		    
                    veccount++;                 // a new point is added to the current patch
                    tempvec[veccount] = bptr;
                    currp = pbin;               //  new probability is recorded
                    binid[bptr] = binptr; // each index will be assigned a bin

                }                
                else if(fabs(fabs(bin)-fabs(currp)) > fabs(currp) && ncandtot > 0)//&& ndim==2)    // if adding a point doesn't bring you closer to the bin edge and the residual is bigger than total current probability
                {                                   // this only happens if you have reached a dead end or adding a candiate takes further from the bin edge
                    patch = 1;
                    //printf("here\n");
                    for (k=1 ; k <= veccount ; k++)
                    {
                        bestp=0.0;
                        for(j=1 ; j <= totcand ; j++)
                        {
                            if (keyp[neigh[k][j]] >= bestp)
                            {
                                neighb = binid[neigh[k][j]];
                                bestp  = keyp [neigh[k][j]];
                            }
                        }
                        binid[tempvec[k]]=neighb;
                    }
                    residual=bin-currp;
                }
                else{

                    bcent[binptr][1]=cent[1];
                    bcent[binptr][2]=cent[2];
                    bcent[binptr][3]=cent[3];
                    binptr ++;    // start new bin - and if binptr has defined M bins it will leave the big while loop  ** refer c i
                    patch = 1;    // exits the nested while loop    ** refer c ii
                    residual=bin-currp;
                    totprob=totprob+currp;
                }
            //binptr is probability of point being evaluated
            //currp is the current probability i.e. the point being evaluated and any neighbours being added to region
            //pbin probability of the current neighbour being evaluated
            //printf ("%i %f %f %f %f %f %f %i %f\n", binptr, currp, pbin, bestp, residual, bin,totprob, M-binptr, (1-totprob)/ ( (double)(M- (1-binptr) ) ) );

        }  // ends patch while loop


    } // ends all bins while loop
         
        residual = 0.0;
        for (i=0 ; i < DUM_N ; i++) // Add grid points that fall outside of all defined regions into the region they are closest to (centroid)
        {
            //printf ("%i %f %i\n", i, keyp[i], binid[i]);

        }
        
        residual = 0.0;
        for (i=0 ; i < DUM_N ; i++) // Add grid points that fall outside of all defined regions into the region they are closest to (centroid)
         {

             if (binid[i] == 0)
             {
                 for (j=1 ; j<= M ; j++)
                 {
                     dist1 = sqrt( pow( (float)numtabi[i]-bcent[j][1],2) + pow( (float)numtabj[i]-bcent[j][2],2) + pow( (float)numtabk[i]-bcent[j][3],2 ) )/(float)ndim;
                     if (dist1 <= residual || j == 1)
                     {
                         residual = dist1;
                         binid[i]=j;
                     }
                 }
             } // at this point everything has a binid
             pd[binid[i]]=pd[binid[i]]+keyp[i];     // pd is an array that has M elements that contain the probability of that region.
             cls[binid[i]]++;                       // cls keeps track of how many grid points defines each region - these are used later to add points to grids if necessary
         }
        
        currp=0.0;
        near=0.0;
        bptr=0;

        if(binptr-1 != M)
        {
            j = M-(binptr-1);
            for (i=0 ; i < j ; i++) // for each bin that has been left undefined (if M=6 and total number of bins are 5, than there is 1 undefined bin left)
            {
                bptr=0;
                currp=0.0;
                for (k = 1; k <= M ; k++) // check each region to find the one with the highest probability and which contains more points than are defined in it.
                {
                    
                // find bin with highest probability - add an extra point to that bin if the number of points in that bin is not fully occupied
                    if (pd[k] > currp && cls[k] > 1)
                    {
                        bptr=k;
                        currp=pd[k];
                    }
                
                } // at this point all bins have been evaluated to identify a bin with more than 1 point and the highest probability
                if (bptr > 0 ) // it wouldn't make sense if this is not true!
                {
                    addp[bptr]++;
                    cls[bptr]=cls[bptr]-1;
                    pd[bptr]=pd[bptr]/2.0;
                }
            }
        }

        
        msorta(binid,key,keyp,numtabi,numtabj,numtabk,0,DUM_N-1); //

        // pick random points in each bin [2]
        binptr=1;
        ptr=0;
        near=-1.0;
        tempf=0.0;
        sumtemp=0.0;
        i=0;


             for (j=0; j< DUM_N ; j++)
             {

                if (force == 1 && ndim == 1 && numtabi[j] == 0 ) key[j]=1.0;
                if (force == 1 && ndim == 2 && numtabi[j] == 0 && numtabj[j] == 0 ) key[j]=1.0;
                if (force == 1 && ndim == 3 && numtabi[j] == 0 && numtabj[j] == 0 && numtabk[j] == 0 ) key[j]=1.0;

                 if (near==-1.0)
                 {
                     binfloor=j;
                     near=0.0;
                 }
                 if (binid[j+1] != binid[j] || j == DUM_N-1)    // IF THIS IS THE LAST POINT OF THE CURRENT BIN, OR THIS IS THE LAST POINT
                 {
                     binceil = j;
                    for (k=0; k <= addp[binid[j]] ; k++)
                    {
                        for (l = binfloor ; l <= binceil ; l++)
                        {
                            if (key[l] > near)
                            {
                                ptr=l;
                                near=key[l];
                            }


                        }

                        numtabi[i]=numtabi[ptr];
                        numtabj[i]=numtabj[ptr];
                        numtabk[i]=numtabk[ptr];
                        tempf=tempf+keyp[ptr];
                        key[ptr]=-1.0;
                        near=-1.0;
                        i++;

                    }
                 }
             }



        //printf ("TE sens %f , Rel sens %f\n", tempf/(float)M, (tempf/(float)M) / (1.0/((float)DUM_N) ));

        
        

        
     } // end jittered
    
    thresh=0.0;
    if (jit == -1)   // when it is jittered sort array keyp for all values ** for jittering based on probabilities only (not really jittering)
    {

        bin=1/(double)M;

        msort(keyp,key,numtabi,numtabj,numtabk,0,DUM_N-1); // SORTS IN DECENDING ORDER BASED ON KEYP

        for (i=0 ; i < DUM_N ; i++)
         {
             keyp[i]=keyp[i]/sumtemp;     // at this point i will never be evaluated again, so it can be scaled

             if (i>0) keyp[i]=keyp[i]+keyp[i-1]; // also the point is made cumulative
         }

        for (i=0 ; i < M ; i++)    // define M bin borders and store these in binlim
        {
            binlim[i]=0;
            nearest = (double)DUM_N;
            for (j=i ; j < DUM_N ; j++)
            {
                near=fabs( keyp[j] - ((double)i+1) * bin);
                if (near < nearest)   // if I compare keyp to bin, and it is closer to bin than the next point, then this is the
                {                    // upper edge of the box, *** At this point I may want to weight the edge of the box *note keyp is cumulative***
                     binlim[i]=j;   // binlim contains ptr positions corresponding to decending probability order
                     nearest=near;
                }

            }
        }
        

        // pick random points in each bin [5]
        irand=0;
        sumtemp=0.0;
        tempf=keyp[0];
        binfloor=0;
        tempfx=0.0;
        t_rand=0.0;
        nearest=0.0;
        for (j=0 ; j < M ; j++) // M is number of sub points which is also the number of bins
        {
            binfloor=binlim[j-1]+1;
            if (j==0) binfloor=0;
            
                nearest=0.0;
                for (i = binfloor ; i <= binlim[j] ; i++)
                {

                    cpub=keyp[i];   // to get the first point right
                    if (j>0) cpub=keyp[i]-keyp[i-1]; // make non cumulative again

                    if (i == binfloor && j>0)
                    {
                        residual = keyp[i-1]-(((double)j) * bin); // floor compared to lower edge
                        cpub = keyp[i]+residual; // take into account edge effects i.e. residual left when cutting bins
                    }
                    
                    
                    t_rand = (double)rand() / (double)RAND_MAX;
                    tempfx = powf(t_rand,1/cpub);
                    if (tempfx > nearest)
                    {
                        irand = i;
                        nearest=tempfx;
                    }
                irand = binfloor + rand() %( binlim[j]-binfloor +1); // original code
            
                }
            //modulus = goes from 0 to value in brackets minus 1, i.e. if rand() % 1, it will return 0 always.
            //tempfx is recorded in keyp
            
            if (force==1 && j == 0 && numtabi[j] == numtabj[j] == numtabk[j] == 0) irand=0; //override first region if first point is forced. only true when probabilities don't rise from begining
            
            
        
            numtabi[j]=numtabi[irand];
            numtabj[j]=numtabj[irand];
            numtabk[j]=numtabk[irand];
            if (j>0) tempf=keyp[irand]-keyp[irand-1]; // make non cumulative again
            sumtemp=sumtemp+tempf;
            binfloor = binfloor + binlim[j];
            
        }
        //printf ("TE sens %f , Rel sens %f\n", sumtemp/(float)M, (sumtemp/(float)M) / (1.0/((float)DUM_N) ));
        

    } // end jittered
    
	av_num1=0;
	av_num2=0;
	av_num3=0;
// ************* ORDER OUTPUT *****************
if (sort == 1)
{
	for (i=0 ; i < M-1 ; i++)

	{
		for(j=i ; j < M ; j++)
		{
			if (numtabi[i] > numtabi[j])
			{
			
			tempi=numtabi[j];
			numtabi[j]=numtabi[i];
			numtabi[i]=tempi;

			tempi=numtabj[j];
			numtabj[j]=numtabj[i];
			numtabj[i]=tempi;

			tempi=numtabk[j];
			numtabk[j]=numtabk[i];
			numtabk[i]=tempi;

			}
			if (numtabi[i] == numtabi[j] && numtabj[i] > numtabj[j] && ndim > 1)
			{
			tempi=numtabj[j];
			numtabj[j]=numtabj[i];
			numtabj[i]=tempi;

			tempi=numtabk[j];
			numtabk[j]=numtabk[i];
			numtabk[i]=tempi;			
			}			
			if (numtabi[i] == numtabi[j] && numtabj[i] == numtabj[j] && numtabk[i] > numtabk[j] && ndim > 2)
			{

			tempi=numtabk[j];
			numtabk[j]=numtabk[i];
			numtabk[i]=tempi;			
			}				


		}
	}
    // *** CORRECT FOR POSSIBLE PROBLEM OF PICKING THE FIRST POINT TWICE DUE TO FORCE*****
	if (ndim == 1 && numtabi[0]==0)
	{
        force=0;
	}
    
	if (ndim == 2 && numtabi[0]==0 && numtabj[0]==0)
	{
        force=0;
	}
	
	if (ndim == 3 && numtabi[0]==0 && numtabj[0]==0 && numtabk[0]==0)
	{
        force=0; 
	}
}
if (sort != 1)
{
  	for (i=0 ; i < M-1 ; i++)
	{
        if(ndim==1)
        {
            if (numtabi[i] == 0)
            {
                force=0;
                numtabi[i] = numtabi[0];
                numtabi[0] = 0 ;                    // forces the first point to 0 if 0 is present in the list
            }
        }
        if(ndim==2)
        {
            if (numtabi[i] == 0 && numtabj[i]==0)
            {
                force=0;
                numtabi[i] = numtabi[0] ;
                numtabj[i] = numtabj[0] ;
                numtabj[0] = 0 ;
                numtabi[0] = 0 ;
            }
        }
        if(ndim==3)
        {
            if (numtabi[i] == 0 && numtabj[i]==0 && numtabk[i]==0)
            {
                force=0;
                numtabi[i] = numtabi[0] ;
                numtabj[i] = numtabj[0] ;
                numtabk[i] = numtabk[0] ;
                numtabj[0] = 0 ;
                numtabi[0] = 0 ;
                numtabk[0] = 0 ;
            }
        }
    }
}
// ************ SINGLE FILE OUTPUT toolkit file - prints to fl, fl4  VARIAN ***************
	if (output==0)
	{

	fl  = fopen (sched, "wt"); 

		if (force == 1 && ndim == 1)
		{
		fprintf(fl, "%4i\n", 1);
		M=M-1;				
		}
		if (ndim == 2)
		{
		if (force == 1)
			{ 
				fprintf(fl, "%4i  %4i\n", 1, 1);		
				M=M-1;
			}
		}
		if(ndim == 3)		
		{
		if (force==1)
			{
				fprintf(fl, "%4i  %4i  %4i\n", 1, 1, 1);
				M=M-1;		
			}
		}


	for (i=0 ; i < M ; i++)	 
	{
		if (ndim == 1)
		{
		fprintf(fl, "%4i\n", numtabi[i]+1);
		}

		if (ndim == 2)
		{
		fprintf(fl, "%4i  %4i\n", numtabi[i]+1, numtabj[i]+1);
				av_num2=numtabj[i]+av_num2;
		}
		if (ndim == 3)
		{	
		fprintf(fl, "%4i  %4i  %4i\n", numtabi[i]+1, numtabj[i]+1, numtabk[i]+1);
				av_num3=numtabk[i]+av_num3;		
				av_num2=numtabj[i]+av_num2;					
		}
		av_num1=numtabi[i]+av_num1;
	}
		fclose(fl);	
	}


// ************ MULTIPILE FILE OUTPUT  toolkitfile-1 + toolkit file  VARIAN ***************
	if (output==1)
	{
	sprintf(sched1, "spec_%s",sched);
	fl  = fopen (sched, "wt"); 
	fl2 = fopen (sched1, "wt");

		if (force == 1 && ndim == 1)
		{
		fprintf(fl, "%4i\n", 1);
		fprintf(fl2, "%4i\n", 0);
		M=M-1;				
		}
		if (ndim == 2)
		{
		if (force == 1)
			{ 
				fprintf(fl, "%4i  %4i\n", 1, 1);		
				fprintf(fl2, "%4i  %4i\n", 0, 0);	
				M=M-1;
			}
		}
		if(ndim == 3)		
		{
		if (force==1)
			{
				fprintf(fl, "%4i  %4i  %4i\n", 1, 1, 1);
				fprintf(fl2, "%4i  %4i  %4i\n", 0, 0, 0);				
				M=M-1;		
			}
		}


	for (i=0 ; i < M ; i++)	 
	{
		if (ndim == 1)
		{
		fprintf(fl, "%4i\n", numtabi[i]+1);
		fprintf(fl2, "%4i\n", numtabi[i]);
		}

		if (ndim == 2)
		{
		fprintf(fl, "%4i  %4i\n", numtabi[i]+1, numtabj[i]+1);
		fprintf(fl2, "%4i  %4i\n", numtabi[i], numtabj[i]);
				av_num2=numtabj[i]+av_num2;
		}
		if (ndim == 3)
		{	
		fprintf(fl, "%4i  %4i  %4i\n", numtabi[i]+1, numtabj[i]+1, numtabk[i]+1);
		fprintf(fl2, "%4i  %4i  %4i\n", numtabi[i], numtabj[i], numtabk[i]);
				av_num3=numtabk[i]+av_num3;	
				av_num2=numtabj[i]+av_num2;						
		}
		av_num1=numtabi[i]+av_num1;
	}
		fclose(fl);	
		fclose(fl2);			
	}
	
// ************ MULTIPILE FILE OUTPUT  longlist + toolkit file  BRUKER GW/IB STYLE ***************
	if (output==2)
	{
	sprintf(sched1, "spec_long_%s",sched);
	fl  = fopen (sched, "wt"); 
	fl2 = fopen (sched1, "wt");

		if (force == 1 && ndim == 1)
		{
		fprintf(fl, "%4i\n", 1);
		fprintf(fl2, "%4i\n", 0);
		M=M-1;				
		}
		if (ndim == 2)
		{
		if (force == 1)
			{ 
				fprintf(fl, "%4i  %4i\n", 1, 1);		
				fprintf(fl2, "%4i\n%4i\n", 0, 0);	
				M=M-1;
			}
		}
		if(ndim == 3)		
		{
		if (force==1)
			{
				fprintf(fl, "%4i  %4i  %4i\n", 1, 1, 1);
				fprintf(fl2, "%4i\n%4i\n%4i\n", 0, 0, 0);				
				M=M-1;		
			}
		}


	for (i=0 ; i < M ; i++)	 
	{
		if (ndim == 1)
		{
		fprintf(fl, "%4i\n", numtabi[i]+1);
		fprintf(fl2, "%4i\n", numtabi[i]);
		}

		if (ndim == 2)
		{
		fprintf(fl, "%4i  %4i\n", numtabi[i]+1, numtabj[i]+1);
		fprintf(fl2, "%4i\n%4i\n", numtabi[i], numtabj[i]);
				av_num2=numtabj[i]+av_num2;
		}
		if (ndim == 3)
		{	
		fprintf(fl, "%4i  %4i  %4i\n", numtabi[i]+1, numtabj[i]+1, numtabk[i]+1);
		fprintf(fl2, "%4i\n%4i\n%4i\n", numtabi[i], numtabj[i], numtabk[i]);
				av_num3=numtabk[i]+av_num3;	
				av_num2=numtabj[i]+av_num2;						
		}
		av_num1=numtabi[i]+av_num1;
	}
		fclose(fl);	
		fclose(fl2);			
	}

// ************ MULTIPILE FILE OUTPUT  list 1-3 + toolkit file BRUKER BERMEL STYLE ***************

	if (output==3)
	{
	sprintf(sched1, "l1_%s",sched); 	
	sprintf(sched2, "l2_%s",sched); 
	sprintf(sched3, "l3_%s",sched); 	


	fl  = fopen (sched1, "wt");  // OPEN L1_SCHED FILE
	fl4  = fopen (sched, "wt"); // OPEN STANDARD SCHED FILE
		if (force == 1 && ndim == 1)
		{
		fprintf(fl4, "%4i\n",0);
		fprintf(fl, "%4i\n", 0);
		M=M-1;				
		}
		if (ndim == 2)
		{
		fl2 = fopen (sched2, "wt"); // OPEN L2_SCHED FILE
		if (force == 1)
			{ 
				fprintf(fl4, "%4i  %4i\n", 1, 1);
				fprintf(fl, "%4i\n", 0);
				fprintf(fl2, "%4i\n", 0);			
				M=M-1;
			}				
		}
		if(ndim == 3)
		{
		fl2 = fopen (sched2, "wt"); // OPEN L2_SCHED FILE		
		fl3 = fopen (sched3, "wt");  // OPEN L3_SCHED FILE
		if (force==1)
			{
				fprintf(fl, "%4i\n", 0);
				fprintf(fl2, "%4i\n", 0);				 
				fprintf(fl4, "%4i  %4i  %4i\n", 1, 1, 1);
				fprintf(fl3, "%4i\n", 0);
				M=M-1;			
			}
		}


	for (i=0 ; i < M ; i++)	 
	{
		if (ndim == 1)
		{
		fprintf(fl4, "%4i\n", numtabi[i]+1);
		}
		fprintf(fl, "%4i\n", numtabi[i]);
		if (ndim >= 2)
		{
		if (ndim == 2) 
			{
				fprintf(fl4, "%4i  %4i\n", numtabi[i]+1, numtabj[i]+1);
			}
		fprintf(fl2, "%4i\n", numtabj[i]);
				av_num2=numtabj[i]+av_num2;
		}
		if (ndim == 3)
		{	
		fprintf(fl4, "%4i  %4i  %4i\n", numtabi[i]+1, numtabj[i]+1, numtabk[i]+1);
		fprintf(fl3, "%4i\n", numtabk[i]);
				av_num3=numtabk[i]+av_num3;					
		}
		av_num1=numtabi[i]+av_num1;
	}
	
		fclose(fl4);	
		if (ndim > 1)
		{
			fclose(fl2);
		}	
			if (ndim > 2)
		{
			fclose(fl3);
		}
	}
// -************ MULTIPILE FILE OUTPUT end***************
	

if (numtabi != NULL )
{
	free(numtabi);
}
if (numtabj != NULL )
{
	free(numtabj);
}
if (numtabk != NULL )
{
	free(numtabk);
}
if (key != NULL) 
{
	free(key);
}
if (rand_t != NULL)
{
	free(rand_t);
}


    return 0;
}



void msort(float af1[],float af2[], int ai1[],int ai2[],int ai3[], int l, int h)
{
    int i = 0;
    int length = h - l + 1;
    int pivot  = 0;
    int merge1 = 0;
    int merge2 = 0;
    int ti1[length], ti2[length], ti3[length];
    float tf1[length], tf2[length];
    
    int t1, t2, t3, t4;
    
    
    if(l == h)
        return;
    
    pivot  = (l + h) / 2;
    
    msort(af1, af2, ai1, ai2, ai3, l, pivot);
    msort(af1, af2, ai1, ai2, ai3, pivot + 1, h);
    
    for(i = 0; i < length; i++)
    {
        tf1[i] = af1[l + i];
        tf2[i] = af2[l + i];
        
        ti1[i] = ai1[l + i];
        ti2[i] = ai2[l + i];
        ti3[i] = ai3[l + i];
        
    }
    
    merge1 = 0;
    merge2 = pivot - l + 1;
    
    for(i = 0; i < length; i++)
    {
        if(merge2 <= h - l)
        {
            if(merge1 <= pivot - l)
            {
                if(tf1[merge1] < tf1[merge2])
                {
                    t1=merge2++;
                    af1[i + l] = tf1[t1];
                    af2[i + l] = tf2[t1];
                    
                    ai1[i + l] = ti1[t1];
                    ai2[i + l] = ti2[t1];
                    ai3[i + l] = ti3[t1];
                    
                    
                }
                
                else
                {
                    t2=merge1++;
                    
                    
                    af1[i + l] = tf1[t2];
                    af2[i + l] = tf2[t2];
                    
                    ai1[i + l] = ti1[t2];
                    ai2[i + l] = ti2[t2];
                    ai3[i + l] = ti3[t2];
                    
                }
            }
            
            else
            {
                t3=merge2++;
                
                
                af1[i + l] = tf1[t3];
                af2[i + l] = tf2[t3];
                
                ai1[i + l] = ti1[t3];
                ai2[i + l] = ti2[t3];
                ai3[i + l] = ti3[t3];
                
            }
        }
        
        else
        {
            t4=merge1++;
            
            
            af1[i + l] = tf1[t4];
            af2[i + l] = tf2[t4];
            
            ai1[i + l] = ti1[t4];
            ai2[i + l] = ti2[t4];
            ai3[i + l] = ti3[t4];
            
            
        }
    }
}
void msorta(int ai0[], float af1[],float af2[], int ai1[],int ai2[],int ai3[], int l, int h)
{
    int i = 0;
    int length = h - l + 1;
    int pivot  = 0;
    int merge1 = 0;
    int merge2 = 0;
    int ti0[length], ti1[length], ti2[length], ti3[length];
    float tf1[length], tf2[length];
    
    int t1, t2, t3, t4;
    
    
    if(l == h)
        return;
    
    pivot  = (l + h) / 2;
    
    msorta(ai0, af1, af2, ai1, ai2, ai3, l, pivot);
    msorta(ai0, af1, af2, ai1, ai2, ai3, pivot + 1, h);
    
    for(i = 0; i < length; i++)
    {
        tf1[i] = af1[l + i];
        tf2[i] = af2[l + i];
        
        ti0[i] = ai0[l + i];
        ti1[i] = ai1[l + i];
        ti2[i] = ai2[l + i];
        ti3[i] = ai3[l + i];
        
    }
    
    merge1 = 0;
    merge2 = pivot - l + 1;
    
    for(i = 0; i < length; i++)
    {
        if(merge2 <= h - l)
        {
            if(merge1 <= pivot - l)
            {
                if(ti0[merge1] > ti0[merge2])
                {
                    t1=merge2++;
                    af1[i + l] = tf1[t1];
                    af2[i + l] = tf2[t1];
                    
                    ai0[i + l] = ti0[t1];
                    ai1[i + l] = ti1[t1];
                    ai2[i + l] = ti2[t1];
                    ai3[i + l] = ti3[t1];
                    
                    
                }
                
                else
                {
                    t2=merge1++;
                    
                    
                    af1[i + l] = tf1[t2];
                    af2[i + l] = tf2[t2];
                    
                    ai0[i + l] = ti0[t2];
                    ai1[i + l] = ti1[t2];
                    ai2[i + l] = ti2[t2];
                    ai3[i + l] = ti3[t2];
                    
                }
            }
            
            else
            {
                t3=merge2++;
                
                
                af1[i + l] = tf1[t3];
                af2[i + l] = tf2[t3];
                
                ai0[i + l] = ti0[t3];
                ai1[i + l] = ti1[t3];
                ai2[i + l] = ti2[t3];
                ai3[i + l] = ti3[t3];
                
            }
        }
        
        else
        {
            t4=merge1++;
            
            
            af1[i + l] = tf1[t4];
            af2[i + l] = tf2[t4];
            
            ai0[i + l] = ti0[t4];
            ai1[i + l] = ti1[t4];
            ai2[i + l] = ti2[t4];
            ai3[i + l] = ti3[t4];
            
            
        }
    }
}

